//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <math.h>

#include "Backprop.h"
#include "SelectLearnMul.h"
#include "PictureRecognition.h"
#include "Hough.h"
#include "KohonenMap.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm5 *Form5;
//---------------------------------------------------------------------------
__fastcall TForm5::TForm5(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
neuron**selp;
neuron*inpas[10];
neuron*outas[10];
neuron*hiddens[20][20];
neuron*listcpy[SIZE][SIZE];	//neuron pointer list copy
float etha=0.5;
float maxerr=0.1;
//samples
float InpSample[10][10];
float OutSample[10][10];
float expectedout[10];

float sigmoid(float x){
	if(x<-200)return 0;
	if(x>200)return 1;
	return (1/(1+exp(-x)));
}

float sig(float x){
	return sigmoid(x)-0.5;
}

float sig_diff(float x){
	float s;
	s=sigmoid(x);
	return (1-s)*s;
}

float randweight(){
	float num;
	num=(floor(Random(100)-50))/1000;
	return num;
}

void RandomizeWeights(){
	int x,y,z;
	for(x=0;x<20;x++)for(y=0;y<20;y++)
		if(hiddens[x][y]){
			for(z=0;z<20;z++)if(hiddens[x][y]->link[z]!=NULL)hiddens[x][y]->weight[z]=randweight();
			hiddens[x][y]->threshold=randweight();
		}
}

void propogate(){
	int x,y,s;
	for(x=0;x<20;x++)
		for(y=0;y<20;y++)
			if(hiddens[x][y]){
				hiddens[x][y]->sum=0;
				for(s=0;s<20;s++)if(hiddens[x][y]->link[s])
					hiddens[x][y]->sum+=hiddens[x][y]->weight[s]*hiddens[x][y]->link[s]->axon;
				hiddens[x][y]->sum+=hiddens[x][y]->threshold;
				hiddens[x][y]->axon=sig(hiddens[x][y]->sum);
			}
}

void backprop(){
	int x,y,z;
	//COMPUTE DELTA
	//output layer
	for(x=0;x<10;x++){
		if(outas[x]==NULL)continue;
		outas[x]->delta=expectedout[x]-outas[x]->axon;
		outas[x]->delta*=sig_diff(outas[x]->sum);
	}
	//search last layer
	int lastHlayer;
	for(z=0;z<20;z++)if(hiddens[z][0]==NULL)break;
	lastHlayer=z-2;
	if(lastHlayer<0){ShowMessage("ERROR FATAL");return;}
	//another layers
	for(z=lastHlayer;z>=0;z--){
		for(x=0;x<20;x++){
			if(hiddens[z][x]==NULL)continue;
			hiddens[z][x]->delta=0;
			for(y=0;y<20;y++){
				if(hiddens[z][x]->axonlist[y].axonElem==NULL )break;
				hiddens[z][x]->delta+=*hiddens[z][x]->axonlist[y].wref+hiddens[z][x]->axonlist[y].axonElem->delta;
			}
			hiddens[z][x]->delta*=sig_diff(hiddens[z][x]->sum);
		}
	}
	//CHANGE WEIGHTS
	lastHlayer++;
	for(z=0;z<=lastHlayer;z++){
		for(x=0;x<20;x++){
			if(hiddens[z][x]==NULL)continue;
			for(y=0;y<20;y++)if(hiddens[z][x]->link[y]!=NULL)
				hiddens[z][x]->weight[y]+=etha*hiddens[z][x]->delta*hiddens[z][x]->link[y]->axon;
			hiddens[z][x]->threshold+=etha*hiddens[z][x]->delta;
		}
	}
}

//MODOSITOTT
void propogate2(){
	int x,y,s;
	for(x=0;x<20;x++)
		for(y=0;y<20;y++)
			if(hiddens[x][y]){
				hiddens[x][y]->sum=0;
				for(s=0;s<20;s++)if(hiddens[x][y]->link[s])
					hiddens[x][y]->sum+=hiddens[x][y]->weight[s]*hiddens[x][y]->link[s]->axon;
				hiddens[x][y]->sum+=hiddens[x][y]->threshold;
				hiddens[x][y]->axon=sigmoid(hiddens[x][y]->sum);
			}
}

//MODOSITOTT
int backprop2(){
	int x,y,z;
	//COMPUTE DELTA
	//output layer
	float error=0.0;
	for(x=0;x<10;x++){
		if(outas[x]==NULL)continue;
		outas[x]->delta=expectedout[x]-outas[x]->axon;
		error+=(outas[x]->delta>=0)?outas[x]->delta:-outas[x]->delta;
	}
	if(error<maxerr)
		return 1;//no need to backpropagate.
	//search last layer
	int lastHlayer;
	for(z=0;z<20;z++)if(hiddens[z][0]==NULL)break;
	lastHlayer=z-2;
	if(lastHlayer<0){ShowMessage("ERROR FATAL");return -10000;}
	//another layers
	for(z=lastHlayer;z>=0;z--){
		for(x=0;x<20;x++){
			if(hiddens[z][x]==NULL)continue;
			hiddens[z][x]->delta=0;
			for(y=0;y<20;y++){
				if(hiddens[z][x]->axonlist[y].axonElem==NULL )break;
				hiddens[z][x]->delta+=*hiddens[z][x]->axonlist[y].wref*hiddens[z][x]->axonlist[y].axonElem->delta;
			}
			hiddens[z][x]->delta*=hiddens[z][x]->axon*(1-hiddens[z][x]->axon);
		}
	}
	//CHANGE WEIGHTS
	lastHlayer++;
	float length;
	for(z=0;z<=lastHlayer;z++){
    	length=0.0;
		for(x=0;x<20;x++){
			if(hiddens[z][x]==NULL)continue;
			length+=hiddens[z][x]->axon*hiddens[z][x]->axon;
		}
		if (length<=0.1) length = 0.1;
		for(x=0;x<20;x++){
			if(hiddens[z][x]==NULL)continue;
			for(y=0;y<20;y++)if(hiddens[z][x]->link[y]!=NULL)
				hiddens[z][x]->weight[y]+=etha*hiddens[z][x]->delta*hiddens[z][x]->link[y]->axon/length;
			hiddens[z][x]->threshold+=etha*hiddens[z][x]->delta/length;
		}
	}
	return 0;
}

//Compute error
void nError(){
	float error=0.0;
	float err;
	int sel=0;
	if(Form5->RadioButton1->Checked)sel=0;
	if(Form5->RadioButton2->Checked)sel=1;
	if(Form5->RadioButton3->Checked)sel=2;
	if(Form5->RadioButton4->Checked)sel=3;
	if(Form5->RadioButton5->Checked)sel=4;
	if(Form5->RadioButton6->Checked)sel=5;
	if(Form5->RadioButton7->Checked)sel=6;
	if(Form5->RadioButton8->Checked)sel=7;
	if(Form5->RadioButton9->Checked)sel=8;
	if(Form5->RadioButton10->Checked)sel=9;
	int x;
	for(x=0;x<10;x++){
		if(outas[x]==NULL)continue;
		err=OutSample[sel][x]-outas[x]->axon;
		error+=(err>=0)?err:-err;
	}
	AnsiString s;
	s.sprintf("%f",error);
	Form5->Edit31->Text=s;
}

//Create Axon list for neurons for backpropogation
void BuildLocalNetwork(){
	int x,y,z;
	for(x=0;x<20;x++)for(y=0;y<20;y++)if(hiddens[x][y])hiddens[x][y]->axonlist=NULL;
	for(x=0;x<20;x++)for(y=0;y<20;y++)if(hiddens[x][y]){
		hiddens[x][y]->axonlist=new(neuron::AxonList[20]);
		for(z=0;z<20;z++){
			hiddens[x][y]->axonlist[z].axonElem=NULL;
			hiddens[x][y]->axonlist[z].wref=0;
		}
	}
	//back annotation
	for(z=1;z<20;z++){
		for(x=0;x<20;x++){
			if(hiddens[z][x]){
				for(y=0;y<20;y++){
					if(hiddens[z][x]->link[y])hiddens[z][x]->link[y]->AddAxonlist(hiddens[z][x],&hiddens[z][x]->weight[y]);
				}
			}
		}
	}
}

//Clear Axon list of neurons
void DestroyLocalNetwork(){
	int x,y;
	for(x=0;x<20;x++)for(y=0;y<20;y++)
		if(hiddens[x][y]&&hiddens[x][y]->axonlist)delete hiddens[x][y]->axonlist;
}

void TForm5::SetSelected(neuron** sel){
	selp=sel;
}
//---------------------------------------------------------------------------
void __fastcall TForm5::FormCreate(TObject *Sender)
{
	Edit1->Text="#";
	Edit2->Text="#";
	Edit3->Text="#";
	Edit4->Text="#";
	Edit5->Text="#";
	Edit6->Text="#";
	Edit7->Text="#";
	Edit8->Text="#";
	Edit9->Text="#";
	Edit10->Text="#";
	Edit11->Text="#";
	Edit12->Text="#";
	Edit13->Text="#";
	Edit14->Text="#";
	Edit15->Text="#";
	Edit16->Text="#";
	Edit17->Text="#";
	Edit18->Text="#";
	Edit19->Text="#";
	Edit20->Text="#";

	AnsiString s;
	s.sprintf("%f",maxerr);
	Edit32->Text=s;
	int x,y;
	for(x=0;x<10;x++){
		inpas[x]=NULL;outas[x]=NULL;
	}
	for(x=0;x<20;x++){
		for(y=0;y<20;y++){
			hiddens[x][y]=NULL;
		}
	}
	editchange=0;
	TrackBar1->Position=25;
	TrackBar2->Position=25;
	TrackBar3->Position=25;
	TrackBar4->Position=25;
	TrackBar5->Position=25;
	TrackBar6->Position=25;
	TrackBar7->Position=25;
	TrackBar8->Position=25;
	TrackBar9->Position=25;
	TrackBar10->Position=25;
	for(x=0;x<10;x++)for(y=0;y<10;y++){
		InpSample[x][y]=0;
		OutSample[x][y]=0;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm5::inp_assoc(TObject *Sender, WORD &Key, TShiftState Shift)
{
	//input association
	int i;
	if((Key=='D')&&(Shift.Contains(ssCtrl))){
		for(i=0;i<10;i++)inpas[i]=NULL;
	}
	if((Key=='A')&&(Shift.Contains(ssCtrl))){
		if(*selp==NULL)return;
		for (i = 0; i < 10; i++) {
			if(inpas[i]==*selp)return;
		}
		if(Sender==Edit11){
			(*selp)->axon=0;
			Edit11->Text="0.0";
			TrackBar1->Position=25;
			inpas[0]=*selp;
		}
		if(Sender==Edit12){
			(*selp)->axon=0;
			Edit12->Text="0.0";
			TrackBar2->Position=25;
			inpas[1]=*selp;
		}
		if(Sender==Edit13){
			(*selp)->axon=0;
			Edit13->Text="0.0";
			TrackBar3->Position=25;
			inpas[2]=*selp;
		}
		if(Sender==Edit14){
			(*selp)->axon=0;
			Edit14->Text="0.0";
			TrackBar4->Position=25;
			inpas[3]=*selp;
		}
		if(Sender==Edit15){
			(*selp)->axon=0;
			Edit15->Text="0.0";
			TrackBar5->Position=25;
			inpas[4]=*selp;
		}
		if(Sender==Edit16){
			(*selp)->axon=0;
			Edit16->Text="0.0";
			TrackBar6->Position=25;
			inpas[5]=*selp;
		}
		if(Sender==Edit17){
			(*selp)->axon=0;
			Edit17->Text="0.0";
			TrackBar7->Position=25;
			inpas[6]=*selp;
		}
		if(Sender==Edit18){
			(*selp)->axon=0;
			Edit18->Text="0.0";
			TrackBar8->Position=25;
			inpas[7]=*selp;
		}
		if(Sender==Edit19){
			(*selp)->axon=0;
			Edit19->Text="0.0";
			TrackBar9->Position=25;
			inpas[8]=*selp;
		}
		if(Sender==Edit20){
			(*selp)->axon=0;
			Edit20->Text="0.0";
			TrackBar10->Position=25;
			inpas[9]=*selp;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm5::outp_assoc(TObject *Sender, WORD &Key,
	  TShiftState Shift)
{
	//output association
	if((Key=='D')&&(Shift.Contains(ssCtrl))){
		for(int i=0;i<10;i++)outas[i]=NULL;
	}
	if((Key=='A')&&(Shift.Contains(ssCtrl))){
		if(*selp==NULL)return;
		for (int i = 0; i < 10; i++) {
			if(outas[i]==*selp)return;
		}
		AnsiString s;
		if(Sender==Edit1){
			outas[0]=*selp;
		}
		if(Sender==Edit2){
			outas[1]=*selp;
		}
		if(Sender==Edit3){
			outas[2]=*selp;
		}
		if(Sender==Edit4){
			outas[3]=*selp;
		}
		if(Sender==Edit5){
			outas[4]=*selp;
		}
		if(Sender==Edit6){
			outas[5]=*selp;
		}
		if(Sender==Edit7){
			outas[6]=*selp;
		}
		if(Sender==Edit8){
			outas[7]=*selp;
		}
		if(Sender==Edit9){
			outas[8]=*selp;
		}
		if(Sender==Edit10){
			outas[9]=*selp;
		}
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm5::e11(TObject *Sender)
{
	if(inpas[0]!=NULL){
		editchange=1;
		*selp=inpas[0];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::e12(TObject *Sender)
{
	if(inpas[1]!=NULL){
		editchange=1;
		*selp=inpas[1];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::e13(TObject *Sender)
{
	if(inpas[2]!=NULL){
		editchange=1;
		*selp=inpas[2];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::e14(TObject *Sender)
{
	if(inpas[3]!=NULL){
		editchange=1;
		*selp=inpas[3];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::e15(TObject *Sender)
{
	if(inpas[4]!=NULL){
		editchange=1;
		*selp=inpas[4];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::e16(TObject *Sender)
{
	if(inpas[5]!=NULL){
		editchange=1;
		*selp=inpas[5];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::e17(TObject *Sender)
{
	if(inpas[6]!=NULL){
		editchange=1;
		*selp=inpas[6];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::e18(TObject *Sender)
{
	if(inpas[7]!=NULL){
		editchange=1;
		*selp=inpas[7];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::e19(TObject *Sender)
{
	if(inpas[8]!=NULL){
		editchange=1;
		*selp=inpas[8];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::e20(TObject *Sender)
{
	if(inpas[9]!=NULL){
		editchange=1;
		*selp=inpas[9];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s1(TObject *Sender)
{
	if(!inpas[0])return;
	AnsiString s;
	float pos=(TrackBar1->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit11->Text=s;
	inpas[0]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s2(TObject *Sender)
{
	if(!inpas[1])return;
	AnsiString s;
	float pos=(TrackBar2->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit12->Text=s;
	inpas[1]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s3(TObject *Sender)
{
	if(!inpas[2])return;
	AnsiString s;
	float pos=(TrackBar3->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit13->Text=s;
	inpas[2]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s4(TObject *Sender)
{
	if(!inpas[3])return;
	AnsiString s;
	float pos=(TrackBar4->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit14->Text=s;
	inpas[3]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s5(TObject *Sender)
{
	if(!inpas[4])return;
	AnsiString s;
	float pos=(TrackBar5->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit15->Text=s;
	inpas[4]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s6(TObject *Sender)
{
	if(!inpas[5])return;
	AnsiString s;
	float pos=(TrackBar6->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit16->Text=s;
	inpas[5]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s7(TObject *Sender)
{
	if(!inpas[6])return;
	AnsiString s;
	float pos=(TrackBar7->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit17->Text=s;
	inpas[6]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s8(TObject *Sender)
{
	if(!inpas[7])return;
	AnsiString s;
	float pos=(TrackBar8->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit18->Text=s;
	inpas[7]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s9(TObject *Sender)
{
	if(!inpas[8])return;
	AnsiString s;
	float pos=(TrackBar9->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit19->Text=s;
	inpas[8]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::s10(TObject *Sender)
{
	if(!inpas[9])return;
	AnsiString s;
	float pos=(TrackBar10->Position-25)*0.04;
	s.sprintf("%f",pos);
	Edit20->Text=s;
	inpas[9]->axon=pos;
}
//---------------------------------------------------------------------------

void __fastcall TForm5::Timer1Timer(TObject *Sender)
{
	//Polling timer for output axon editor
	AnsiString s;
	if(outas[0]){
		s.sprintf("%f",outas[0]->axon);
		Edit1->Text=s;
	}
	if(outas[1]){
		s.sprintf("%f",outas[1]->axon);
		Edit2->Text=s;
	}
	if(outas[2]){
		s.sprintf("%f",outas[2]->axon);
		Edit3->Text=s;
	}
	if(outas[3]){
		s.sprintf("%f",outas[3]->axon);
		Edit4->Text=s;
	}
	if(outas[4]){
		s.sprintf("%f",outas[4]->axon);
		Edit5->Text=s;
	}
	if(outas[5]){
		s.sprintf("%f",outas[5]->axon);
		Edit6->Text=s;
	}
	if(outas[6]){
		s.sprintf("%f",outas[6]->axon);
		Edit7->Text=s;
	}
	if(outas[7]){
		s.sprintf("%f",outas[7]->axon);
		Edit8->Text=s;
	}
	if(outas[8]){
		s.sprintf("%f",outas[8]->axon);
		Edit9->Text=s;
	}
	if(outas[9]){
		s.sprintf("%f",outas[9]->axon);
		Edit10->Text=s;
	}

	//Propogation forward
	if(CheckBox1->Checked)propogate2();
	//Compute error
	nError();
}
//---------------------------------------------------------------------------

void AddHiddens(int row, neuron* n){
	int x,y;
	for(x=0;x<20;x++)for(y=0;y<20;y++)if(hiddens[x][y]==n)return;
	for(x=0;x<20;x++){
		if(!hiddens[row][x]){
			hiddens[row][x]=n;
			return;
		}
	}
	ShowMessage("ERROR too much hidden neurons");
}

int IsInputNeu(neuron* n){
	int x;
	for(x=0;x<10;x++)if(inpas[x]==n)return 1;
	return 0;
}

void __fastcall TForm5::CheckBox1Click(TObject *Sender)
{
	int x,y;
	int posx=19,posy=0;
	int inputreached=0;
	neuron*lookatinput=NULL;
	if(CheckBox1->Checked){
		for(x=0;x<20;x++) for(y=0;y<20;y++) hiddens[x][y]=NULL;
		for(x=0;x<10;x++){
			if(inpas[x]){lookatinput=inpas[x];break;}
		}
		if(!lookatinput){
			ShowMessage("ERROR no input neuron defined");
			return;
		}
		for(x=0;x<10;x++){
			for(y=0;y<20;y++)
				if(outas[x]&&outas[x]->link[y])
					AddHiddens(posx,outas[x]->link[y]);
		}
		posx--;
		while(!inputreached){
			for(x=0;x<20;x++){
				for(y=0;y<20;y++){
				  if( hiddens[posx+1][x] && hiddens[posx+1][x]->link[y] ){
					if(IsInputNeu(hiddens[posx+1][x]->link[y]))inputreached=1;
					else{
						AddHiddens(posx,hiddens[posx+1][x]->link[y]);
					}
				  }
				}
			}
            posx--;
		}
		int firstArow=0;
		for(x=0;x<20;x++){
			int ures=1;
			for(y=0;y<20;y++)if(hiddens[x][y])ures=0;
			if(!ures){
				firstArow=x;break;
			}
		}
		if(firstArow)
		  for(x=firstArow;x<20;x++){
			for(y=0;y<20;y++){
				hiddens[x-firstArow][y]=hiddens[x][y];
				hiddens[x][y]=NULL;
			}
		  }
		firstArow=20-firstArow;
		if(firstArow==20){
			ShowMessage("ERROR too much neurons");
			return ;
		}
		for(x=0;x<10;x++){
			hiddens[firstArow][x]=outas[x];
		}
	}
}
//---------------------------------------------------------------------------

//SAVE
void __fastcall TForm5::Button2Click(TObject *Sender)
{
	TStringList* config;
	AnsiString s;
	int x,y;
	SaveDialog1->Filter="ANN association configuration (*.acf)|*.ACF";
	if(SaveDialog1->Execute()){
		config=new TStringList;
		s.sprintf("%d",TrackBar1->Position);
		config->Add(s);
		s.sprintf("%d",TrackBar2->Position);
		config->Add(s);
		s.sprintf("%d",TrackBar3->Position);
		config->Add(s);
		s.sprintf("%d",TrackBar4->Position);
		config->Add(s);
		s.sprintf("%d",TrackBar5->Position);
		config->Add(s);
		s.sprintf("%d",TrackBar6->Position);
		config->Add(s);
		s.sprintf("%d",TrackBar7->Position);
		config->Add(s);
		s.sprintf("%d",TrackBar8->Position);
		config->Add(s);
		s.sprintf("%d",TrackBar9->Position);
		config->Add(s);
		s.sprintf("%d",TrackBar10->Position);
		config->Add(s);

		for(x=0;x<10;x++){
			if(inpas[x]!=NULL)	s.sprintf("%d",inpas[x]->posx);
			else s="-1";
			config->Add(s);
			if(inpas[x]!=NULL) s.sprintf("%d",inpas[x]->posy);
			else s="-1";
			config->Add(s);
		}
		for(x=0;x<10;x++){
			if(outas[x]!=NULL) s.sprintf("%d",outas[x]->posx);
			else s="-1";
			config->Add(s);
			if(outas[x]!=NULL) s.sprintf("%d",outas[x]->posy);
			else s="-1";
			config->Add(s);
		}

		for(x=0;x<10;x++){
			for(y=0;y<10;y++){
				s.sprintf("%f",InpSample[x][y]);
				config->Add(s);
				s.sprintf("%f",OutSample[x][y]);
				config->Add(s);
			}
		}

		config->SaveToFile(ChangeFileExt(SaveDialog1->FileName,".acf"));
		delete config;
	}
}
//---------------------------------------------------------------------------


//LOAD
void __fastcall TForm5::Button1Click(TObject *Sender)
{
	TStringList* config;
	AnsiString s;
	int x,y,posx,posy;
	OpenDialog1->Filter="ANN association configuration (*.acf)|*.ACF";
	if(OpenDialog1->Execute()){
		config=new TStringList;
		config->LoadFromFile(OpenDialog1->FileName);
		TrackBar1->Position=config->Strings[0].ToInt();
		TrackBar2->Position=config->Strings[1].ToInt();
		TrackBar3->Position=config->Strings[2].ToInt();
		TrackBar4->Position=config->Strings[3].ToInt();
		TrackBar5->Position=config->Strings[4].ToInt();
		TrackBar6->Position=config->Strings[5].ToInt();
		TrackBar7->Position=config->Strings[6].ToInt();
		TrackBar8->Position=config->Strings[7].ToInt();
		TrackBar9->Position=config->Strings[8].ToInt();
		TrackBar10->Position=config->Strings[9].ToInt();
		if(TrackBar1->Position!=25)Edit11->Text=config->Strings[0];
		if(TrackBar2->Position!=25)Edit12->Text=config->Strings[1];
		if(TrackBar3->Position!=25)Edit13->Text=config->Strings[2];
		if(TrackBar4->Position!=25)Edit14->Text=config->Strings[3];
		if(TrackBar5->Position!=25)Edit15->Text=config->Strings[4];
		if(TrackBar6->Position!=25)Edit16->Text=config->Strings[5];
		if(TrackBar7->Position!=25)Edit17->Text=config->Strings[6];
		if(TrackBar8->Position!=25)Edit18->Text=config->Strings[7];
		if(TrackBar9->Position!=25)Edit19->Text=config->Strings[8];
		if(TrackBar10->Position!=25)Edit20->Text=config->Strings[9];

		int cnt=10;
		for(x=0;x<10;x++){
			posx=config->Strings[cnt++].ToInt();
			posy=config->Strings[cnt++].ToInt();
			if(posx==-1)continue;
			if(list[posx][posy]==NULL){
				ShowMessage("ERROR Invalid location");
			return;
			}
			inpas[x]=list[posx][posy];
		}
		for(x=0;x<10;x++){
			posx=config->Strings[cnt++].ToInt();
			posy=config->Strings[cnt++].ToInt();
			if(posx==-1)continue;
			if(list[posx][posy]==NULL){
				ShowMessage("ERROR Invalid location");
				return;
			}
			outas[x]=list[posx][posy];
		}
//		if(config->Count>cnt+50)
		for(x=0;x<10;x++){
			for(y=0;y<10;y++){
				InpSample[x][y]=config->Strings[cnt++].ToDouble();
				OutSample[x][y]=config->Strings[cnt++].ToDouble();
			}
		}

		delete config;
	}
	RadioButton1Click(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe1(TObject *Sender)
{
	if(outas[0]!=NULL){
		editchange=1;
		*selp=outas[0];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe2(TObject *Sender)
{
	if(outas[1]!=NULL){
		editchange=1;
		*selp=outas[1];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe3(TObject *Sender)
{
	if(outas[2]!=NULL){
		editchange=1;
		*selp=outas[2];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe4(TObject *Sender)
{
	if(outas[3]!=NULL){
		editchange=1;
		*selp=outas[3];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe5(TObject *Sender)
{
	if(outas[4]!=NULL){
		editchange=1;
		*selp=outas[4];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe6(TObject *Sender)
{
	if(outas[5]!=NULL){
		editchange=1;
		*selp=outas[5];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe7(TObject *Sender)
{
	if(outas[6]!=NULL){
		editchange=1;
		*selp=outas[6];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe8(TObject *Sender)
{
	if(outas[7]!=NULL){
		editchange=1;
		*selp=outas[7];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe9(TObject *Sender)
{
	if(outas[8]!=NULL){
		editchange=1;
		*selp=outas[8];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::oe10(TObject *Sender)
{
	if(outas[9]!=NULL){
		editchange=1;
		*selp=outas[9];
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::Button3Click(TObject *Sender)
{
	//GET sample
	TRadioButton* rbt[10];
	TTrackBar*    ttt[10];
	TEdit*	      tet[10];
	TEdit*	      tesample[10];
	rbt[0]=RadioButton1;
	rbt[1]=RadioButton2;
	rbt[2]=RadioButton3;
	rbt[3]=RadioButton4;
	rbt[4]=RadioButton5;
	rbt[5]=RadioButton6;
	rbt[6]=RadioButton7;
	rbt[7]=RadioButton8;
	rbt[8]=RadioButton9;
	rbt[9]=RadioButton10;
	ttt[0]=TrackBar1;
	ttt[1]=TrackBar2;
	ttt[2]=TrackBar3;
	ttt[3]=TrackBar4;
	ttt[4]=TrackBar5;
	ttt[5]=TrackBar6;
	ttt[6]=TrackBar7;
	ttt[7]=TrackBar8;
	ttt[8]=TrackBar9;
	ttt[9]=TrackBar10;
	tet[0]=Edit1;
	tet[1]=Edit2;
	tet[2]=Edit3;
	tet[3]=Edit4;
	tet[4]=Edit5;
	tet[5]=Edit6;
	tet[6]=Edit7;
	tet[7]=Edit8;
	tet[8]=Edit9;
	tet[9]=Edit10;

	tesample[0]=Edit21;
	tesample[1]=Edit22;
	tesample[2]=Edit23;
	tesample[3]=Edit24;
	tesample[4]=Edit25;
	tesample[5]=Edit26;
	tesample[6]=Edit27;
	tesample[7]=Edit28;
	tesample[8]=Edit29;
	tesample[9]=Edit30;

	int x,y;
	for(x=0;x<10;x++){
		if(rbt[x]->Checked){
			for(y=0;y<10;y++){
				InpSample[x][y]=(ttt[y]->Position-25)*0.04;
				if(tet[y]->Text.AnsiCompare("#"))
					OutSample[x][y]=tesample[y]->Text.ToDouble();
			}
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm5::RadioButton1Click(TObject *Sender)
{
	TRadioButton* rbt[10];
	TTrackBar*    ttt[10];
	TEdit*	      tetinp[10];
	TEdit*	      tetout[10];
	TEdit*	      tesample[10];
	rbt[0]=RadioButton1;
	rbt[1]=RadioButton2;
	rbt[2]=RadioButton3;
	rbt[3]=RadioButton4;
	rbt[4]=RadioButton5;
	rbt[5]=RadioButton6;
	rbt[6]=RadioButton7;
	rbt[7]=RadioButton8;
	rbt[8]=RadioButton9;
	rbt[9]=RadioButton10;
	ttt[0]=TrackBar1;
	ttt[1]=TrackBar2;
	ttt[2]=TrackBar3;
	ttt[3]=TrackBar4;
	ttt[4]=TrackBar5;
	ttt[5]=TrackBar6;
	ttt[6]=TrackBar7;
	ttt[7]=TrackBar8;
	ttt[8]=TrackBar9;
	ttt[9]=TrackBar10;
	tetout[0]=Edit1;
	tetout[1]=Edit2;
	tetout[2]=Edit3;
	tetout[3]=Edit4;
	tetout[4]=Edit5;
	tetout[5]=Edit6;
	tetout[6]=Edit7;
	tetout[7]=Edit8;
	tetout[8]=Edit9;
	tetout[9]=Edit10;
	tetinp[0]=Edit11;
	tetinp[1]=Edit12;
	tetinp[2]=Edit13;
	tetinp[3]=Edit14;
	tetinp[4]=Edit15;
	tetinp[5]=Edit16;
	tetinp[6]=Edit17;
	tetinp[7]=Edit18;
	tetinp[8]=Edit19;
	tetinp[9]=Edit20;

	tesample[0]=Edit21;
	tesample[1]=Edit22;
	tesample[2]=Edit23;
	tesample[3]=Edit24;
	tesample[4]=Edit25;
	tesample[5]=Edit26;
	tesample[6]=Edit27;
	tesample[7]=Edit28;
	tesample[8]=Edit29;
	tesample[9]=Edit30;

	int x,y;
	AnsiString s;
	//Send sample to inputs
	int radio=-1;
	for(x=0;x<10;x++){
		if(rbt[x]->Checked)radio=x;
	}
	if(radio==-1){ShowMessage("FATAL");return;}
	for(x=0;x<10;x++){
		if(inpas[x]){
			ttt[x]->Position= InpSample[radio][x]/0.04+25;
			s.sprintf("%f",InpSample[radio][x]);
			tetinp[x]->Text=s;
			inpas[x]->axon=InpSample[radio][x];
		}
	}
	for(x=0;x<10;x++){
		if(outas[x]){
			s.sprintf("%f",OutSample[radio][x]);
			tesample[x]->Text=s;
		}
	}
}
//---------------------------------------------------------------------------

//LEARN
void __fastcall TForm5::Button4Click(TObject *Sender)
{
//learning
	int z;
	TRadioButton* rbt[10];
	rbt[0]=RadioButton1;
	rbt[1]=RadioButton2;
	rbt[2]=RadioButton3;
	rbt[3]=RadioButton4;
	rbt[4]=RadioButton5;
	rbt[5]=RadioButton6;
	rbt[6]=RadioButton7;
	rbt[7]=RadioButton8;
	rbt[8]=RadioButton9;
	rbt[9]=RadioButton10;
	int selr;
	for(z=0;z<10;z++)if(rbt[z]->Checked)selr=z;
	for(z=0;z<10;z++)if(inpas[z])inpas[z]->axon=InpSample[selr][z];	
	for(z=0;z<10;z++)expectedout[z]=OutSample[selr][z];

	BuildLocalNetwork();
//	RandomizeWeights();

	int ok=0;
	for(z=0;z<10000;z++){
		propogate2();
		ok=backprop2();
		if(ok==-10000)break;
		if(ok){
			AnsiString s;
			s.sprintf("OK: Minimal error is reched in %d loops",z);
			ShowMessage(s);
			break;
		}
	}

	DestroyLocalNetwork();
}
//---------------------------------------------------------------------------
//MULTI learn
void __fastcall TForm5::Button5Click(TObject *Sender)
{
	int i,z,e,f,whilecnt;
	int t[10];
	float minerr;
	float error[10];
	for(i=0;i<10;i++)t[i]=0;
	if(Form6->ShowModal()==mrOk ){
		if(Form6->CheckBox1->Checked)t[0]=1;
		if(Form6->CheckBox2->Checked)t[1]=1;
		if(Form6->CheckBox3->Checked)t[2]=1;
		if(Form6->CheckBox4->Checked)t[3]=1;
		if(Form6->CheckBox5->Checked)t[4]=1;
		if(Form6->CheckBox6->Checked)t[5]=1;
		if(Form6->CheckBox7->Checked)t[6]=1;
		if(Form6->CheckBox8->Checked)t[7]=1;
		if(Form6->CheckBox9->Checked)t[8]=1;
		if(Form6->CheckBox10->Checked)t[9]=1;
	}
	BuildLocalNetwork();
//	RandomizeWeights();

	int ok[10];
	int okall=0;
	for(e=0;e<10;e++)ok[e]=1;
	for(e=0;e<10000;e++){
		for(i=0;i<10;i++)
			if(t[i]){
				for(z=0;z<10;z++)if(inpas[z])inpas[z]->axon=InpSample[i][z];			
				for(z=0;z<10;z++)expectedout[z]=OutSample[i][z];
				propogate2();
				ok[i]=backprop2();
			}
		okall=1;
		for(i=0;i<10;i++)if(!ok[i])okall=0;
		if(okall){
			AnsiString s;
			s.sprintf("All learning error is below error min. Finished in %d loops",e);
			ShowMessage(s);
			break;
		}
	}

	DestroyLocalNetwork();
}
//---------------------------------------------------------------------------

void __fastcall TForm5::Button6Click(TObject *Sender)
{
	RandomizeWeights();
}
//---------------------------------------------------------------------------

void __fastcall TForm5::Button7Click(TObject *Sender)
{
	maxerr=Edit32->Text.ToDouble();
}
//---------------------------------------------------------------------------

//Picture Recognition
void __fastcall TForm5::Image1Click(TObject *Sender)
{
	Form7->init();
	Form7->Show();
}
//---------------------------------------------------------------------------

//Hough transform
void __fastcall TForm5::Image3Click(TObject *Sender)
{
//HOUGH
	Form8->Show();
}
//---------------------------------------------------------------------------

//Kohonen Map
void __fastcall TForm5::Image2Click(TObject *Sender)
{
//KOHONEN
	Form9->Show();
}
//---------------------------------------------------------------------------

