//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Hough.h"
#include <stdio.h>

#include "fft2d.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm8 *Form8;
FILE*f;

#define MINGRAPHPOINTS 5										//threshold

//normalize reskep
void TForm8::normalize(){
	int x,y;
	int max=0;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(reskep[x][y]>max)max=reskep[x][y];
		}
	if(!max)return;
	float t;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			t=(float)reskep[x][y]/(float)max*255.0;
			reskep[x][y]=t;
		}
}

//Draw out the picture
void TForm8::Drawout(int kep[OSZ][SOR]){
	int x,y;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=kep[x][y];
}

void TForm8::fputint(int x){
	char t[4];
	*(int*)t=x;
	int w;
	for(w=0;w<4;w++)fputc(t[w],f);
}
void TForm8::fputfloat(float x){
	char t[4];
	*(float*)t=x;
	int w;
	for(w=0;w<4;w++)fputc(t[w],f);
}
int TForm8::fgetint(){
	char t[4];
	int w;
	for(w=0;w<4;w++)t[w]=fgetc(f);
	return *(int*)t;
}
float TForm8::fgetfloat(){
	char t[4];
	int w;
	for(w=0;w<4;w++)t[w]=fgetc(f);
	return *(float*)t;
}

//Subgraph functions for eliminate noise from edge graph
int TForm8::CountSpike(ldata*ld){
	int cnt=1;
	ldata* futo=ld->link[0];
	if(!futo) return cnt;
	while(futo->linknum==2){
		cnt++;
		if(futo->link[0]!=ld){
			ld=futo;
			futo=futo->link[0];
		}
		else{
        	ld=futo;
			futo=futo->link[1];
		}
		if(!futo)return cnt;
	}
	return cnt;
}

void TForm8::DeleteSpike(ldata*ld){
	ldata* futo=ld->link[0];
	int x;
	while(ld->linknum==1){
		for(x=0;x<futo->linknum;x++)
			if(futo->link[x]==ld){
				futo->link[x]=NULL;
				futo->linknum--;
				for(;x<futo->linknum;x++){
					futo->link[x]=futo->link[x+1];
				}
				futo->link[futo->linknum]=NULL;
				break;
			}
		delete L[ ld->X ][ ld->Y ];
		L[ ld->X ][ ld->Y ]=NULL;
		ld=futo;
		futo=futo->link[0];
	}
}

int RenumberedNum;
//Numbering graph
void TForm8::RenumberGraph(ldata* start,int gnum){
/*
	if(LocalAngleCompuEN){	//compute local angle for line detection
		float angle1,angle2;
		if(start->link[0]&&start->link[1]){
			angle1=atan( (float)(start->link[0]->Y-start->link[1]->Y) / (float)(start->link[0]->X-start->link[1]->X) );
			if(start->link[0]->link[0]&&start->link[1]->link[0]){
				angle2=atan( (float)(start->link[0]->link[0]->Y-start->link[1]->link[0]->Y) /
							 (float)(start->link[0]->link[0]->X-start->link[1]->link[0]->X) );
				start->LocalAngle=(angle1+angle2)/2.0;
			}else
            	start->LocalAngle=angle1;
		}
	}
*/
	RenumberedNum++;
	start->graphord=gnum;
	int w;
	for(w=0;w<start->linknum;w++){
		if( !start->link[w] ) break;
		if( start->link[w]->graphord!=gnum )
			RenumberGraph(start->link[w],gnum);
	}
}

//Searching Continuous curves
//dir: 1->towards startpoint  2->towards endpoint
int TForm8::ClusterizeSubCurve(ldata* ld, ldata* axon, int clusterNo, char dir){
	ldata* futo=axon;
	if(futo->CurveCluster>=0)
		return 0;		//Furcsa helyzet - ilyenkor tul nagy a pontok tmrlese, 2 tobbszomszedu pont talalkozasakor megeshet
	int fuss;
	int curpntpoi=500;
	int x;
	if(cur[curpoi].points==NULL){
		ShowMessage("ERROR  cur[curpoi].points==NULL");
		return -1;
	}
	if(cur[clusterNo].points[curpntpoi]!=ld){
		cur[clusterNo].points[curpntpoi]=ld;
		cur[clusterNo].num++;
	}

	//towards startpoint
	if(dir==1){
		fuss=1;
		curpntpoi--;
		while(fuss){
			if(futo->CurveCluster>=0)break;
			//registering
			if(curpntpoi<1){
				ShowMessage("ERROR curpntpoi overflow");
				return -1;
			}
			cur[clusterNo].points[curpntpoi--]=futo;


//TEST
//			Image1->Canvas->Pixels[futo->X][futo->Y]=0x0000FF;
//			ShowMessage("OK");


			cur[clusterNo].num++;
			if(futo->linknum<=2)futo->CurveCluster=clusterNo;
			//step futo and endpointer
			cur[clusterNo].startpoint=futo;
			if(futo->linknum==1){
				fuss=0;
			}else if(futo->linknum==2){
				if(futo->link[0]!=ld){
					ld=futo;
					futo=futo->link[0];
				}else{
					ld=futo;
					futo=futo->link[1];
				}
			}else{
				if(!futo->linkpairs)fuss=0;
				else{
					for(x=0;x<10;x++){
						if(futo->link[x]==ld)break;
					}
					if(x>9){
						ShowMessage("ERROR back annotation error");
						return -1;
					}
					else{
						ld=futo;
						if(!futo->linkpairs[x])break;
						futo=*futo->linkpairs[x];
					}
				}
			}
		}
	}

	//towards endpoint	
	if(dir==2){
		fuss=1;
		curpntpoi++;
		while(fuss){
        	if(futo->CurveCluster>=0)break;		
			//registering
			if(curpntpoi>999){
				ShowMessage("ERROR curpntpoi overflow");
				return -1;
			}
			cur[clusterNo].points[curpntpoi++]=futo;
			cur[clusterNo].num++;
			if(futo->linknum<=2)futo->CurveCluster=clusterNo;
			//step futo and endpointer
			cur[clusterNo].startpoint=futo;
			if(futo->linknum==1){
				fuss=0;
			}else if(futo->linknum==2){
				if(futo->link[0]!=ld){
					ld=futo;
					futo=futo->link[0];
				}else{
					ld=futo;
					futo=futo->link[1];
				}
			}else{
				if(!futo->linkpairs)fuss=0;
				else{
					for(x=0;x<10;x++){
						if(futo->link[x]==ld)break;
					}
					if(x>9){
						ShowMessage("ERROR back annotation error");
						return -1;
					}
					else{
						ld=futo;
						if(!futo->linkpairs[x])break;						
						futo=*futo->linkpairs[x];
					}
				}
			}
		}
	}

	return 0;

}

//Creating linking pairs for detecting lines. This shows which neighbours are on a line.
void TForm8::CreateLinkPairs(ldata* ld){
	int x,y;
	float a1,a2;
	if(ld->linknum<=2){
		ld->linkpairs=NULL;
		return;
	}
	if(ld->linkpairs)return;
	ld->linkpairs=new(ldata**[10]);
	for(x=0;x<10;x++)ld->linkpairs[x]=NULL;
	for(x=0;x<ld->linknum;x++)
		for(y=0;y<ld->linknum;y++){
			if(x==y)continue;
			if(ld->linkpairs[x]||ld->linkpairs[y])continue;
			a1=AtanQuotient( (ld->link[x]->Y - ld->Y) , (ld->link[x]->X - ld->X) );
			a2=AtanQuotient( (ld->link[y]->Y - ld->Y) , (ld->link[y]->X - ld->X) );
			if( fabs(a2-a1)<0.1 ){		//threshold!
				ld->linkpairs[x]=&ld->link[y];
				ld->linkpairs[y]=&ld->link[x];
			}
		}
	y=0;
	for(x=0;x<10;x++)
		if(ld->linkpairs[x])y=1;
	if(!y){
		delete ld->linkpairs;
		ld->linkpairs=NULL;
	}
}

//---------------------------------------------------------------------------
//CONSTRUCTOR
__fastcall TForm8::TForm8(TComponent* Owner)
	: TForm(Owner)
{
	H=NULL;
	L=NULL;
	stat=NULL;
	cur=NULL;
	enableCur=1;
	LocalAngleCompuEN=0;
}

//---------------------------------------------------------------------------
//OPEN
void __fastcall TForm8::Button1Click(TObject *Sender)
{
	if(OpenPictureDialog1->Execute()){
		Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
	}
}
//---------------------------------------------------------------------------


//CANNY edge detection
void __fastcall TForm8::Button2Click(TObject *Sender)
{
//COLOR -> BLACK&WHITE
	int x,y;
	int c;
	int m,n;
	int t;

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			OriKep[x][y]=Image1->Picture->Bitmap->Canvas->Pixels[x][y];
		}

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			c=Image1->Picture->Bitmap->Canvas->Pixels[x][y];
			inputkep[x][y]=(c&0xFF)/3+(c&0xFF00)/256/3+(c&0xFF0000)/256/256/3;
			BWkep[x][y]=inputkep[x][y]+inputkep[x][y]*256+inputkep[x][y]*256*256;
		}
		
//COPY
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			reskep[x][y]=inputkep[x][y];
		}

//GAUSS
	int gaussop[5][5]={
		2,4,5,4,2,
		4,9,12,9,4,
		5,12,15,12,5,
		4,9,12,9,4,
		2,4,5,4,2
	};
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			reskep[x][y]=0;
		}
	for(y=2;y<SOR-2;y++)
		for(x=2;x<OSZ-2;x++){
			t=0;
			for(m=-2;m<3;m++)
				for(n=-2;n<3;n++)
					t+=inputkep[x+m][y+n]*gaussop[m+2][n+2];
			reskep[x][y]=t;
		}
	normalize();

//SOBEL OPERATOR
	int sobelop1[3][3]={
		-1,0,1,
		-2,0,2,
		-1,0,1
	};
	int sobelop2[3][3]={
		1,2,1,
		0,0,0,
		-1,-2,-1
	};
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			inputkep[x][y]=reskep[x][y];
			reskep[x][y]=0;
			thetas[x][y]=0;
		}
	int z;
	for(y=1;y<SOR-1;y++)
		for(x=1;x<OSZ-1;x++){
			t=0;z=0;
			for(m=-1;m<2;m++)
				for(n=-1;n<2;n++){
					t+=inputkep[x+m][y+n]*sobelop1[m+1][n+1];
					z+=inputkep[x+m][y+n]*sobelop2[m+1][n+1];
				}
			incl[x][y].dx=t;
			incl[x][y].dy=z;
			reskep[x][y]=sqrt(t*t+z*z);
			if(t==0){
				(z<0)?thetas[x][y]=-PI/2:thetas[x][y]=PI/2;
			}
			else thetas[x][y]=atan((float)z/(float)t);
		}

//SEPARATE EDGES BY ORIENTATION
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			linecolimage[x][y]=0;
		}

	float angle=0.0;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(reskep[x][y]>2){		//Threshold 1
				angle=thetas[x][y];
				if((angle>=-PI/2)&&(angle<-3*PI/8))linecolimage[x][y]=0x00FFFF;
				else if((angle>=-3*PI/8)&&(angle<-PI/8))linecolimage[x][y]=0xFF0000;
				else if((angle>=-PI/8)&&(angle<PI/8))
					linecolimage[x][y]=0x00FF00;
				else if((angle>=PI/8)&&(angle<3*PI/8))linecolimage[x][y]=0x0000FF;
				else if((angle>=3*PI/8)&&(angle<PI/2))linecolimage[x][y]=0x00FFFF;
			}else reskep[x][y]=0;
		}

//NONMAXIMUM SUPRESSION
/*
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			switch(linecolimage[x][y]){
				case 0x00FFFF:
					inputkep[x][y]=reskep[x][y]*256+reskep[x][y];
					break;
				case 0xFF0000:
					inputkep[x][y]=reskep[x][y]*256*256;
					break;
				case 0x00FF00:
					inputkep[x][y]=reskep[x][y]*256;
					break;
				case 0x0000FF:
					inputkep[x][y]=reskep[x][y];
					break;
				default:
					inputkep[x][y]=0;
					break;
			}
		}
	//idaig az inputkep-ben szines irany kiemelt elek vannak de elmosott elek
*/
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
        	inputkep[x][y]=reskep[x][y];
		}

	//0x00FFFF:	sarga vizszintes
	//0xFF0000:	kek EK-DNY
	//0x00FF00:	zold fuggoleges
	//0x0000FF:	piros ENY-DK

	int* line=new(int[SOR]);
	int* mask=new(int[SOR]);
	for(x=0;x<OSZ;x++){
		for(y=0;y<SOR;y++){
			if(linecolimage[x][y]==0x00FF00){ line[y]=reskep[x][y]; mask[y]=0; }
			else mask[y]=1;
		}
		for(y=1;y<SOR-1;y++)if((line[y-1]<line[y])&&(line[y+1]<line[y])) mask[y]=1;
		for(y=0;y<SOR;y++)if(!mask[y]) inputkep[x][y]=0;
	}
	delete[] line;
	delete[] mask;


	line=new(int[OSZ]);
	mask=new(int[OSZ]);
	for(y=0;y<SOR;y++){
		for(x=0;x<OSZ;x++){
			if(linecolimage[x][y]==0x00FFFF){
				line[x]=reskep[x][y]; mask[x]=0;
			}
			else mask[x]=1;
		}
		for(x=1;x<OSZ-1;x++)if((line[x-1]<line[x])&&(line[x+1]<line[x])) mask[x]=1;
		for(x=0;x<OSZ;x++)if(!mask[x]) inputkep[x][y]=0;
	}
	delete[] line;
	delete[] mask;

	//rezsutosan
	for(x=0;x<OSZ;x++)//pre delete
		for(y=0;y<SOR;y++)
			if((linecolimage[x][y]==0x0000FF)||(linecolimage[x][y]==0xFF0000))
				inputkep[x][y]=0;

	line=new(int[SOR]);
	mask=new(int[SOR]);
	for(x=0;x<OSZ;x++){
		for(y=0;y<SOR;y++){
			mask[y]=0;
			if((linecolimage[x][y]==0x0000FF)||(linecolimage[x][y]==0xFF0000))
				line[y]=reskep[x][y];
		}
		for(y=1;y<SOR-1;y++)if((line[y-1]<line[y])&&(line[y+1]<line[y])) mask[y]=1;
		for(y=0;y<SOR;y++)if(mask[y]){
			if(linecolimage[x][y]==0x0000FF)
				inputkep[x][y]=reskep[x][y];
			if(linecolimage[x][y]==0xFF0000)
				inputkep[x][y]=reskep[x][y];//*256*256;
		}
	}
	delete[] line;
	delete[] mask;

	line=new(int[OSZ]);
	mask=new(int[OSZ]);
	for(y=0;y<SOR;y++){
		for(x=0;x<OSZ;x++){
			mask[x]=0;
			if((linecolimage[x][y]==0x0000FF)||(linecolimage[x][y]==0xFF0000))
				line[x]=reskep[x][y];
		}
		for(x=1;x<OSZ-1;x++)if((line[x-1]<line[x])&&(line[x+1]<line[x])) mask[x]=1;
		for(x=0;x<OSZ;x++)if(mask[x]){
			if(linecolimage[x][y]==0x0000FF)
				inputkep[x][y]=reskep[x][y];
			if(linecolimage[x][y]==0xFF0000)
				inputkep[x][y]=reskep[x][y];//*256*256;
		}
	}
	delete[] line;
	delete[] mask;

//HYSTERESIS THRESHOLDING

  //thetas: direction matrix
  //reskep: intensity matrix
  //inputkep: sent to be drawn
  //linecolimage: direction separated colored pixels
  //OriKep: original color picture
  //BWkep: black and white picture
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			tempkep[x][y]=0;
			if(inputkep[x][y]>30)inputkep[x][y]=0xFFFFFF;		//High threshold Canny
			else if(inputkep[x][y]>10)inputkep[x][y]=0x3F3F3F;	//Low  threshold Canny - not used  
			else inputkep[x][y]=0;
		}
	int searchend=0;
	int actx,acty;
	int nx1,ny1,nx2,ny2,nx3,ny3;
	int nx,ny;
	//positive direction
	for(y=1;y<SOR-1;y++)
		for(x=1;x<OSZ-1;x++){
			if(inputkep[x][y]==0xFFFFFF&&!tempkep[x][y]){
				tempkep[x][y]=1;
				actx=x;acty=y;
				searchend=0;
				while(!searchend){
					switch(linecolimage[actx][acty]){
						case 0x00FFFF:	//sarga vizszintes
							nx1=nx2=nx3=actx-1;
							ny1=acty-1;ny2=acty;ny3=acty+1;
							break;
						case 0xFF0000:	//kek EK-DNY
							nx1=actx-1;ny1=acty+1;
							nx2=actx-1;ny2=acty;
							nx3=actx;ny3=acty+1;
							break;
						case 0x00FF00:	//zold fuggoleges
							ny1=ny2=ny3=acty+1;
							nx1=actx-1;nx2=actx;nx3=actx+1;
							break;
						case 0x0000FF:	//piros ENY-DK
							nx1=actx+1;ny1=acty+1;
							nx2=actx;ny2=acty+1;
							nx3=actx+1;ny3=acty;
							break;
					}
					(reskep[nx1][ny1]>reskep[nx2][ny2])?nx=nx1,ny=ny1:nx=nx2,ny=ny2;
					if(reskep[nx3][ny3]>reskep[nx][ny])nx=nx3,ny=ny3;

					if(tempkep[nx][ny]||inputkep[nx][ny]==0xFFFFFF){
						searchend=1; continue;
					}
					if(reskep[nx][ny]>1){				//Threshold: vonalkovetesi minimum threshold - low threshold Canny
						tempkep[nx][ny]=1;inputkep[x][y]=0x00FFFF;
						actx=nx;acty=ny;
					}else searchend=1;
				}
			}
		}
	//negative direction
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			tempkep[x][y]=0;
		}
	for(y=1;y<SOR-1;y++)
		for(x=1;x<OSZ-1;x++){
			if(inputkep[x][y]==0xFFFFFF&&!tempkep[x][y]){
				tempkep[x][y]=1;
				actx=x;acty=y;
				searchend=0;
				while(!searchend){
					switch(linecolimage[actx][acty]){
						case 0x00FFFF:	//sarga vizszintes
							nx1=nx2=nx3=actx+1;
							ny1=acty-1;ny2=acty;ny3=acty+1;
							break;
						case 0xFF0000:	//kek EK-DNY
							nx1=actx+1;ny1=acty-1;
							nx2=actx+1;ny2=acty;
							nx3=actx;ny3=acty-1;
							break;
						case 0x00FF00:	//zold fuggoleges
							ny1=ny2=ny3=acty-1;
							nx1=actx-1;nx2=actx;nx3=actx+1;
							break;
						case 0x0000FF:	//piros ENY-DK
							nx1=actx-1;ny1=acty-1;
							nx2=actx;ny2=acty-1;
							nx3=actx-1;ny3=acty;
							break;
					}
					(reskep[nx1][ny1]>reskep[nx2][ny2])?nx=nx1,ny=ny1:nx=nx2,ny=ny2;
					if(reskep[nx3][ny3]>reskep[nx][ny])nx=nx3,ny=ny3;

					if(tempkep[nx][ny]||inputkep[nx][ny]==0xFFFFFF){
						searchend=1; continue;
					}
					if(reskep[nx][ny]>1){				//Threshold: vonalkovetesi minimum threshold - low threshold Canny
						tempkep[nx][ny]=1;inputkep[x][y]=0x00FF00;
						actx=nx;acty=ny;
					}else searchend=1;
				}
			}
		}

	//thresholded supressed picture is available

//NOISY PIXEL SUPRESSION
//MAGANYOS 1-2-3 PIXELNYI CSOPORTOK LESZEDESE
	for(y=1;y<SOR-1;y++)//color conversion
		for(x=1;x<OSZ-1;x++){
			if(inputkep[x][y]==0x00FFFF||inputkep[x][y]==0xFFFFFF||inputkep[x][y]==0x00FF00)inputkep[x][y]=0xFFFFFF;
			else inputkep[x][y]=0;
		}

	int cscnt;		//csoport counter
	for(y=1;y<SOR-1;y++)
		for(x=1;x<OSZ-1;x++){
			if(inputkep[x][y]){
				cscnt=0;nx=0;ny=0;
				for(acty=-1;acty<2;acty++)
					for(actx=-1;actx<2;actx++)
						if(inputkep[x+actx][y+acty]){
							nx=x+actx;ny=y+acty;cscnt++;
						}
				if(cscnt==1)inputkep[x][y]=0;
/*
				if(cscnt==2){
					cscnt=0;
					for(acty=-1;acty<2;acty++)
						for(actx=-1;actx<2;actx++)
							if(inputkep[nx+actx][ny+acty])cscnt++;
					if(cscnt==2){
						inputkep[nx][ny]=0;
						inputkep[x][y]=0;
					}
				}
*/
			}
		}

//DELETE EDGES ON FOUR EDGES
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if((x<3)||(x>OSZ-4)||(y<3)||(y>SOR-4))
            	inputkep[x][y]=0;
		}

//DRAW OUT RESULTS

	for(y=0;y<SOR;y++)			//convert for drawing: ->BW edge pic.
		for(x=0;x<OSZ;x++){
			if(inputkep[x][y]==0x00FFFF||inputkep[x][y]==0xFFFFFF)inputkep[x][y]=0;
			else inputkep[x][y]=0xFFFFFF;
		}


/*
	//mix with original picture
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(inputkep[x][y])inputkep[x][y]=reskep[x][y];
			else inputkep[x][y]=0x00FFFF;
		}
*/

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=inputkep[x][y];
		}
}

//---------------------------------------------------------------------------
//HOUGH TRANSFORM
void __fastcall TForm8::Button3Click(TObject *Sender)
{
	int x,y,z;

//TEST
/*
	for(x=0;x<500;x++){
		y=(int)(  (float)x*sin(2.88)/cos(2.88)  -385.0/cos(2.88)  );
		Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0x0000FF;
	}
	for(x=0;x<500;x++){
		y=(int)(  (float)x*sin(1.04)/cos(1.04)  +70.0/cos(1.04)  );
		Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0x0000FF;
	}
*/

//DELETE
	if(stat){
		for(x=0;x<12;x++)delete[] stat[x];
		delete[] stat;
	}
	if(H){
		for(y=0;y<SOR;y++)
			for(x=0;x<OSZ;x++)
				if(H[x][y])
					delete H[x][y];
		for(x=0;x<OSZ;x++)delete[] H[x];
		delete[] H;
	}

//	FilterTheta();

//Statistic
	H=new(hough**[OSZ]);
	for(x=0;x<OSZ;x++)H[x]=new(hough*[SOR]);
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			if(!inputkep[x][y]){
				H[x][y]=new(hough);
				H[x][y]->theta =(thetas[x][y]>0.0)?thetas[x][y]:thetas[x][y]+PI;
				H[x][y]->radius=(float)y*cos(H[x][y]->theta)-(float)x*sin(H[x][y]->theta);
				H[x][y]->lineclass=0;
				H[x][y]->lineclasspoi=NULL;
				H[x][y]->X=x;
				H[x][y]->Y=y;
			}else
				H[x][y]=NULL;

	stat=new(linestat*[12]);
	for(x=0;x<12;x++)stat[x]=new(linestat[200]);

	int pstatord=0;
	int classcnt=0;

	for(x=0;x<12;x++)
		for(y=0;y<200;y++){
			stat[x][y].theta =(float)x*PI/11.0;
			stat[x][y].radius=(float)y*10.0-520.0;
			stat[x][y].num=0;
			stat[x][y].fuzzynum=0.0;
			stat[x][y].xcoord=x;
			stat[x][y].ycoord=y;
			stat[x][y].lineclass=classcnt++;
			statord[pstatord++] =&stat[x][y];
			for(z=0;z<OSZ;z++){
				stat[x][y].points[z]=NULL;
			}
		}

	int xcoord,ycoord;
	for(y=0;y<SOR;y++)			//classify
		for(x=0;x<OSZ;x++){
			if(H[x][y]==NULL)continue;
			//class coordinates
			xcoord=(H[x][y]->theta)*11.0/PI;
			ycoord=(H[x][y]->radius+520.0)/10.0;
			//average coputing
			if(stat[xcoord][ycoord].num==0){
				stat[xcoord][ycoord].theta=H[x][y]->theta;
				stat[xcoord][ycoord].radius=H[x][y]->radius;
			}else{
				stat[xcoord][ycoord].theta=(stat[xcoord][ycoord].theta*(float)stat[xcoord][ycoord].num+H[x][y]->theta)/((float)stat[xcoord][ycoord].num+1.0);
				stat[xcoord][ycoord].radius=(stat[xcoord][ycoord].radius*(float)stat[xcoord][ycoord].num+H[x][y]->radius)/((float)stat[xcoord][ycoord].num+1.0);
			}
			//register the point into class
			stat[xcoord][ycoord].points[stat[xcoord][ycoord].num++]=H[x][y];
			stat[xcoord][ycoord].fuzzynum+=1.0;
			//fuzzify
/*
			if(xcoord>0){
				stat[xcoord-1][ycoord].points[stat[xcoord-1][ycoord].num++]=H[x][y];
				stat[xcoord-1][ycoord].fuzzynum+=0.5;
			}
			if(ycoord>0){
				stat[xcoord][ycoord-1].points[stat[xcoord][ycoord-1].num++]=H[x][y];
				stat[xcoord][ycoord-1].fuzzynum+=0.5;
			}
			if(xcoord<11){
				stat[xcoord+1][ycoord].points[stat[xcoord+1][ycoord].num++]=H[x][y];
				stat[xcoord+1][ycoord].fuzzynum+=0.5;
			}
			if(ycoord<199){
				stat[xcoord][ycoord+1].points[stat[xcoord][ycoord+1].num++]=H[x][y];
				stat[xcoord][ycoord+1].fuzzynum+=0.5;
			}
*/
			//classify point entity
			H[x][y]->lineclass=stat[xcoord][ycoord].lineclass;
			H[x][y]->lineclasspoi=&stat[xcoord][ycoord];
		}

	//buborek for stat
	int csere=1;
	linestat* tmp;
	while(csere){
		csere=0;
		for(z=0;z<STATORDMAX-1;z++){
			if(statord[z]->num < statord[z+1]->num ){
				tmp=statord[z];
				statord[z]=statord[z+1];
				statord[z+1]=tmp;
				csere=1;
			}
		}
	}


//CUT
/*
	int atlag=0;
	for(x=0;x<12;x++){
		for(y=0;y<200;y++){
			atlag+=stat[x][y].num;
		}
	}
	atlag/=2400;
	int numoflines=0;
	for(x=0;x<12;x++){
		for(y=0;y<200;y++){
			if(stat[x][y].num<atlag)stat[x][y].num=0;
			if(stat[x][y].num)numoflines++;
		}
	}
*/
/*
	AnsiString ms;
	ms.sprintf("Number of found lines=%d",numoflines);
	ShowMessage(ms);
*/	

//Follow found line and reclasterize
/*
	LineFollow();
	LineFollow();
	LineFollow();
*/			

//TEST
	FILE*f;
	f=fopen("d:\\temp\\data.txt","w");
	for(y=0;y<SOR;y++){
		for(x=0;x<OSZ-400;x++){
			if(H[x][y]){
				if(H[x][y]->lineclass<10)
					fprintf(f,"   %d ",H[x][y]->lineclass);
				else if(H[x][y]->lineclass<100)
					fprintf(f,"  %d ",H[x][y]->lineclass);
				else if(H[x][y]->lineclass<1000)
					fprintf(f," %d ",H[x][y]->lineclass);
				else
					fprintf(f,"%d ",H[x][y]->lineclass);
			}else{
				fprintf(f,"   0 ");
			}
		}
		fprintf(f,"\n");
	}
	fclose(f);


/*
	//DROP SMALL or broken LINES
	float avlen;
	for(z=0;z<STATORDMAX;z++){
		for(x=0;x<statord[z]->num;x++){
//			if(statord[z]->points[x]-> )
		}
	}
*/


//TEST DRAW LINES
  #define DRAWLINES 1
  #define MARKPOINT 0

  if(DRAWLINES){
	Image1->Picture->Bitmap->Canvas->Pen->Color=0x00FF00;
	int elso;
	for(z=0;z<20;z++){  		//first 20 lines in order
		elso=1;
		for(x=0;x<OSZ;x++){
			y=(float)x*tan(statord[z]->theta)+statord[z]->radius/cos(statord[z]->theta);
			if((y>0)&&(y<SOR)){
				if(elso){
					elso=0;
					Image1->Picture->Bitmap->Canvas->MoveTo(x,y);
				}else{
					Image1->Picture->Bitmap->Canvas->LineTo(x,y);
				}
			}
		}
		for(x=0;x<statord[z]->num;x++){
			Image1->Picture->Bitmap->Canvas->Pixels[statord[z]->points[x]->X ][statord[z]->points[x]->Y ]=0x0000FF;
		}
/*
		Application->ProcessMessages();
		MsgWaitForMultipleObjectsEx(0,NULL,500,0,0);
*/		
	}
  }

  if(MARKPOINT){
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(inputkep[x][y])continue;
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0x00FFFF;
		}
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(inputkep[x][y])continue;
			for(z=0;z<200;z++){
				if(H[x][y]->lineclass == statord[z]->lineclass){
					Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0xFF0000;
				}
			}
		}
  }


}

//Follow found line and reclasterize
void __fastcall TForm8::LineFollow(){
	int x,y;
	int _num;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y]&&L[x][y]->linknum>=2){
				if( H[x][y]->lineclass!=H[ L[x][y]->link[0]->X ][ L[x][y]->link[0]->Y ]->lineclass ||
					H[x][y]->lineclass!=H[ L[x][y]->link[1]->X ][ L[x][y]->link[1]->Y ]->lineclass  ){

					if(	H[ L[x][y]->link[0]->X ][ L[x][y]->link[0]->Y ]->lineclasspoi->num >
						H[ L[x][y]->link[1]->X ][ L[x][y]->link[1]->Y ]->lineclasspoi->num ){

						_num=H[ L[x][y]->link[0]->X ][ L[x][y]->link[0]->Y ]->lineclasspoi->num;
						H[ L[x][y]->link[0]->X ][ L[x][y]->link[0]->Y ]->lineclasspoi->num++;
						H[ L[x][y]->link[0]->X ][ L[x][y]->link[0]->Y ]->lineclasspoi->points[_num]=H[x][y];
					}else{
						_num=H[ L[x][y]->link[1]->X ][ L[x][y]->link[1]->Y ]->lineclasspoi->num;
						H[ L[x][y]->link[1]->X ][ L[x][y]->link[1]->Y ]->lineclasspoi->num++;
						H[ L[x][y]->link[1]->X ][ L[x][y]->link[1]->Y ]->lineclasspoi->points[_num]=H[x][y];
					}
				}
			}
		}
}

//Filetering Thetas
void __fastcall TForm8::FilterTheta(){
	int x,y;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y]&&L[x][y]->linknum==2){
				thetas[x][y]=(thetas[x][y]+
					thetas[ L[x][y]->link[0]->X ][ L[x][y]->link[0]->Y ]+
					thetas[ L[x][y]->link[1]->X ][ L[x][y]->link[1]->Y ])/3.0;
			}
		}
}

//---------------------------------------------------------------------------
//LINE DETECTION 1
void __fastcall TForm8::Button4Click(TObject *Sender)
{
//Line detection
	int curveclasscnt=0;
	int x,y,z;

	linfo*** L;
	L=new(linfo**[OSZ]);
	for(x=0;x<OSZ;x++)L[x]=new(linfo*[SOR]);
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			if(!inputkep[x][y]) L[x][y]=new(linfo);
			else L[x][y]=NULL;

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y]){
				for(z=0;z<10;z++) L[x][y]->link[z]=NULL;
				L[x][y]->linknum=0;
				L[x][y]->endpoint=0;
				L[x][y]->curvature=0;		//alapbol egyenes
				L[x][y]->curveclassno=0;
				L[x][y]->xindex=x;
				L[x][y]->yindex=y;
			}
		}

	int tavx,tavy;
	linfo* futo;
	int searchend=0;

	float mindistance;
	linfo* elem;

	struct searchtab{
		float tavolsag;
		float iranyszog;
		linfo* talaltelem;
	}shtab[11][11];

	linedata* ldat;
	int ldatp=-1;
	ldat=new(linedata[15000]);
	for(y=0;y<5000;y++){
		ldat[y].start=NULL;
		ldat[y].end=NULL;
		ldat[y].pnum=0;
		ldat[y].circle=0;
	}

	for(tavy=0;tavy<11;tavy++){
		for(tavx=0;tavx<11;tavx++){
			shtab[tavx][tavy].tavolsag=sqrt((tavx-5)*(tavx-5)+(tavy-5)*(tavy-5));
			if(tavx==5){
				if(tavy==5)shtab[tavx][tavy].iranyszog=0.0;
				if(tavy<5)shtab[tavx][tavy].iranyszog=PI/2;
				if(tavy>5)shtab[tavx][tavy].iranyszog=-PI/2;
			}else{
				shtab[tavx][tavy].iranyszog=atan(((float)tavy-5)/((float)tavx-5));
				if(shtab[tavx][tavy].iranyszog==-0.0)shtab[tavx][tavy].iranyszog=0.0;
			}
			shtab[tavx][tavy].talaltelem=NULL;
		}
	}


	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y]){
				if(!L[x][y]->curveclassno ){
				//Curve search in graph and classify
					ldatp++;
					ldat[ldatp].start=L[x][y];
					ldat[ldatp].pnum++;
					curveclasscnt++;
					//POSITIVE DIRECTION
					futo=L[x][y];
					searchend=0;
					while(!searchend){
						for(tavy=0;tavy<11;tavy++)
							for(tavx=0;tavx<11;tavx++)
								shtab[tavx][tavy].talaltelem=NULL;
						for(tavy=0;tavy<11;tavy++)
							for(tavx=0;tavx<11;tavx++)
								if(((futo->xindex+tavx-5)>0)&&((futo->yindex+tavy-5)>0)&&((futo->xindex+tavx-5)<OSZ)&&((futo->yindex+tavy-5)<SOR))
									if(L[futo->xindex+tavx-5][futo->yindex+tavy-5])
										if((shtab[tavx][tavy].iranyszog>thetas[futo->xindex][futo->yindex]-PI/8)&&(shtab[tavx][tavy].iranyszog<thetas[futo->xindex][futo->yindex]+PI/8))//PI/2.5
											shtab[tavx][tavy].talaltelem=L[futo->xindex+tavx-5][futo->yindex+tavy-5];

						mindistance=shtab[0][0].tavolsag+100;
						elem=NULL;
						for(tavy=0;tavy<11;tavy++)
							for(tavx=0;tavx<11;tavx++){
								if((tavx==5)&&(tavy==5)){
									continue;			//onmagat ne talalja meg
								}
								if((futo==L[x][y])&&(tavy<5)){
									continue; 			//elso elemnel csak a pozitiv irany ervenyes
								}
								if(shtab[tavx][tavy].talaltelem)
									if(shtab[tavx][tavy].tavolsag<mindistance ){
										if(shtab[tavx][tavy].talaltelem==futo->link[1])continue;
//										if(shtab[tavx][tavy].talaltelem->curveclassno)continue;
										elem=shtab[tavx][tavy].talaltelem;
										mindistance=shtab[tavx][tavy].tavolsag;
									}
							}

						if(elem&&elem->curveclassno)elem=NULL;
						if(elem){
							futo->link[0]=elem;
							elem->link[1]=futo;
							futo->linknum++;
							elem->linknum++;
							futo->curveclassno=curveclasscnt;
							elem->curveclassno=curveclasscnt;
							futo=elem;
							//line handling
							ldat[ldatp].start=elem;
							ldat[ldatp].pnum++;
						}else{
							searchend=1;
						}
					}
					
					//NEGATIVE DIRECTION
					futo=L[x][y];
					searchend=0;
					while(!searchend){
						for(tavy=0;tavy<11;tavy++)
							for(tavx=0;tavx<11;tavx++)
								shtab[tavx][tavy].talaltelem=NULL;
						for(tavy=0;tavy<11;tavy++)
							for(tavx=0;tavx<11;tavx++)
								if(((futo->xindex+tavx-5)>0)&&((futo->yindex+tavy-5)>0)&&((futo->xindex+tavx-5)<OSZ)&&((futo->yindex+tavy-5)<SOR))
									if(L[futo->xindex+tavx-5][futo->yindex+tavy-5])
										if((shtab[tavx][tavy].iranyszog>thetas[futo->xindex][futo->yindex]-PI/8)&&(shtab[tavx][tavy].iranyszog<thetas[futo->xindex][futo->yindex]+PI/8))//PI/2.5
											shtab[tavx][tavy].talaltelem=L[futo->xindex+tavx-5][futo->yindex+tavy-5];

						mindistance=shtab[0][0].tavolsag+100;
						elem=NULL;
						for(tavy=0;tavy<11;tavy++)
							for(tavx=0;tavx<11;tavx++){
								if((tavx==5)&&(tavy==5))continue;		//onmagat ne talalja meg
								if((futo==L[x][y])&&(tavy>5))continue; 	//elso elemnel csak a negativ irany ervenyes
								if(shtab[tavx][tavy].talaltelem)
									if(shtab[tavx][tavy].tavolsag<mindistance ){
										if(shtab[tavx][tavy].talaltelem==futo->link[1])continue;
//										if(shtab[tavx][tavy].talaltelem->curveclassno)continue;
										elem=shtab[tavx][tavy].talaltelem;
										mindistance=shtab[tavx][tavy].tavolsag;
									}
							}
						if(elem&&elem->curveclassno)elem=NULL;
						if(elem){
							futo->link[1]=elem;
							elem->link[0]=futo;
							futo->linknum++;
							elem->linknum++;
							futo->curveclassno=curveclasscnt;
							elem->curveclassno=curveclasscnt;							
							futo=elem;
							//line handling
							ldat[ldatp].end=elem;
							ldat[ldatp].pnum++;
						}else{
							searchend=1;
						}
					}
				}
			}
		}

	//delete too short lines
	for(y=0;y<ldatp+1;y++){
		if(ldat[y].pnum<3){	//threshold!
			futo=ldat[y].start;
			while(futo){
				futo->curveclassno=0;
				futo=futo->link[0];
			}
			futo=ldat[y].start;
			while(futo){
				futo->curveclassno=0;
				futo=futo->link[1];
			}
		}
	}

	//TEST
	//DRAW TEST
		for(y=0;y<SOR;y++)
			for(x=0;x<OSZ;x++)
				if(L[x][y]&&L[x][y]->curveclassno){
					Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0x0000FF;
				}else if(L[x][y])
						Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0xFF0000;


	delete[] ldat;

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			if(L[x][y]) delete L[x][y];
	for(x=0;x<OSZ;x++)delete[] L[x];
	delete[] L;
}
//---------------------------------------------------------------------------

int mouseX=0;
int mouseY=0;
int click=0;

void __fastcall TForm8::mouse(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	mouseX=X;
	mouseY=Y;
	click=1;
	if(Form10->Visible)return;
	//mouse
	AnsiString s1,s2,s3;
	s1.sprintf("%d",X);
	s2.sprintf("%d",Y);
	s3.sprintf("%f",thetas[X][Y]);
	if(Image1->Picture->Bitmap->Canvas->Pixels[X][Y]!=0xFFFFFF){
		if(H){
			if(H[X][Y]){
				AnsiString MESS="";
				MESS.sprintf("HOUGH\ntheta=%.2f\nradius=%.2f\nlineclass=%d\nX=%d\nY=%d",
					H[X][Y]->theta,
					H[X][Y]->radius,
					H[X][Y]->lineclass,
					H[X][Y]->X,
					H[X][Y]->Y);

				int x,y;
				Image1->Picture->Bitmap->Canvas->Pen->Color=0xFF00FF;
				x=H[X][Y]->X-10;
				y=(float)x*tan(H[X][Y]->theta)+H[X][Y]->radius/cos(H[X][Y]->theta);
				Image1->Picture->Bitmap->Canvas->MoveTo( x,y );
				x=H[X][Y]->X+10;
				y=(float)x*tan(H[X][Y]->theta)+H[X][Y]->radius/cos(H[X][Y]->theta);
				Image1->Picture->Bitmap->Canvas->LineTo( x,y );

				ShowMessage(MESS);
			}
			return;
		}
		if(L==NULL)return;
		AnsiString s4="";
		AnsiString s5="";
		if(L[X][Y]){
			s4.sprintf("\nlinknum=%d\nGraphord=%d\nCurveCluster=%d",L[X][Y]->linknum,L[X][Y]->graphord,L[X][Y]->CurveCluster);
			s5.sprintf("\nDX=%d, DY=%d",incl[X][Y].dx,incl[X][Y].dy);
		}
		ShowMessage("X="+s1+",Y="+s2+"\nTHETA="+s3+s4+s5);
	}
}

//---------------------------------------------------------------------------

void __fastcall TForm8::Button5Click(TObject *Sender)
{
//DO ALL
	Image1->Picture->LoadFromFile("D:\\temp\\Push-pull3.bmp");
//	Image1->Picture->LoadFromFile("D:\\temp\\_proba.bmp");
	if(CheckBox1->Checked)Prefilter();
	Button2Click(Sender);
//	Button3Click(Sender);
	//line detect
	Button6Click(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TForm8::FormClose(TObject *Sender, TCloseAction &Action)
{
	int x;
	int y;	
	if(stat){
		for(x=0;x<12;x++)delete[] stat[x];
		delete[] stat;
	}
	if(H){
		for(y=0;y<SOR;y++)
			for(x=0;x<OSZ;x++)
				if(H[x][y])
					delete H[x][y];
		for(x=0;x<OSZ;x++)delete[] H[x];
		delete[] H;
	}

	if(L){
		for(y=0;y<SOR;y++)
			for(x=0;x<OSZ;x++)
				if(L[x][y]){
					if(L[x][y]->linkpairs )delete[] L[x][y]->linkpairs;
					delete L[x][y];
				}
		for(x=0;x<OSZ;x++)delete[] L[x];
		delete[] L;
	}
}
//---------------------------------------------------------------------------
//LINE DETECTION 2
void __fastcall TForm8::Button6Click(TObject *Sender)
{
	if(L){
		ShowMessage("ERROR 'L' is already created!");
		return;
	}
	int x,y,z,w;
	int m,n;

    cur=NULL;

//LINKING POINTS
	L=new(ldata**[OSZ]);
	for(x=0;x<OSZ;x++)L[x]=new(ldata*[SOR]);
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			L[x][y]=NULL;

	for(y=3;y<SOR-3;y++)
		for(x=3;x<OSZ-3;x++)
			if(!inputkep[x][y]) L[x][y]=new(ldata);


	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y]){
				for(z=0;z<10;z++) L[x][y]->link[z]=NULL;
				L[x][y]->linknum=0;
				L[x][y]->X=x;
				L[x][y]->Y=y;
				L[x][y]->graphord=0;
				L[x][y]->CurveCluster=-1;
				L[x][y]->linkpairs=NULL;
				L[x][y]->LocalAngle=thetas[x][y];
			}
		}

	//truncate four block pixels
	int n1,n2,n3,n4;
	for(y=1;y<SOR-1;y++)
		for(x=1;x<OSZ-1;x++){
			if(L[x][y]&&L[x+1][y]&&L[x][y+1]&&L[x+1][y+1]){
				n1=n2=n3=n4=0;
				for(m=-1;m<2;m++)
					for(n=-1;n<2;n++)
						if(L[x+n][y+m])n1++;
				for(m=-1;m<2;m++)
					for(n=-1;n<2;n++)
						if(L[x+1+n][y+m])n2++;
				for(m=-1;m<2;m++)
					for(n=-1;n<2;n++)
						if(L[x+n][y+1+m])n3++;
				for(m=-1;m<2;m++)
					for(n=-1;n<2;n++)
						if(L[x+1+n][y+1+m])n4++;
				if((n1<=n2)&&(n1<=n3)&&(n1<=n4)){ delete L[x][y];L[x][y]=NULL; }
				else if((n2<=n1)&&(n2<=n3)&&(n2<=n4)){ delete L[x+1][y];L[x+1][y]=NULL; }
				else if((n3<=n1)&&(n3<=n2)&&(n3<=n4)){ delete L[x][y+1];L[x][y+1]=NULL; }
				else{ delete L[x+1][y+1];L[x+1][y+1]=NULL; }
			}
		}

	//Connect neighbour points together
	for(y=1;y<SOR-1;y++)
		for(x=1;x<OSZ-1;x++)
			if(L[x][y]){
				if(L[x-1][y])L[x][y]->link[ L[x][y]->linknum++ ]=L[x-1][y];
				if(L[x+1][y])L[x][y]->link[ L[x][y]->linknum++ ]=L[x+1][y];
				if(L[x][y-1])L[x][y]->link[ L[x][y]->linknum++ ]=L[x][y-1];
				if(L[x][y+1])L[x][y]->link[ L[x][y]->linknum++ ]=L[x][y+1];

				if(L[x-1][y-1]&&!L[x-1][y]&&!L[x][y-1]) L[x][y]->link[ L[x][y]->linknum++ ]=L[x-1][y-1];
				if(L[x+1][y+1]&&!L[x+1][y]&&!L[x][y+1]) L[x][y]->link[ L[x][y]->linknum++ ]=L[x+1][y+1];
				if(L[x-1][y+1]&&!L[x-1][y]&&!L[x][y+1]) L[x][y]->link[ L[x][y]->linknum++ ]=L[x-1][y+1];
				if(L[x+1][y-1]&&!L[x+1][y]&&!L[x][y-1]) L[x][y]->link[ L[x][y]->linknum++ ]=L[x+1][y-1];

			}


	//Collecting and Numbering graphs
	graphdata* gdata;
	int gdatap=1;
	gdata=new(graphdata[2000]);
	gdata[0].startpoint=NULL;
	gdata[0].num=0;

	LocalAngleCompuEN=1;
	for(y=1;y<SOR-1;y++)
		for(x=1;x<OSZ-1;x++)
			if(L[x][y]&&!L[x][y]->graphord){
				gdata[gdatap].startpoint=L[x][y];
				RenumberedNum=0;
				RenumberGraph(L[x][y],gdatap);
				gdata[gdatap].num=RenumberedNum;
				gdata[gdatap].graphnumber=L[x][y]->graphord;
				gdatap++;
				if(gdatap>1900){
					ShowMessage("ERROR gdatap!");
					return;
				}
			}
	LocalAngleCompuEN=0;

	//Search neighbour graphs and connect them together
	struct index{
		int x;
		int y;
		index* next;
	};
	index* si=new(index[16]);
	int sipoi=0;
	si[sipoi].x=0;	si[sipoi].y=-2;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=0;	si[sipoi].y=2;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=-2;	si[sipoi].y=0;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=2;	si[sipoi].y=0;	si[sipoi].next=&si[sipoi+1];	sipoi++;

	si[sipoi].x=-1;	si[sipoi].y=-2;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=1;	si[sipoi].y=-2;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=-1;	si[sipoi].y=2;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=1;	si[sipoi].y=2;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=-2;	si[sipoi].y=1;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=-2;	si[sipoi].y=-1;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=2;	si[sipoi].y=1;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=2;	si[sipoi].y=-1;	si[sipoi].next=&si[sipoi+1];	sipoi++;

	si[sipoi].x=2;	si[sipoi].y=2;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=-2;	si[sipoi].y=-2;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=2;	si[sipoi].y=-2;	si[sipoi].next=&si[sipoi+1];	sipoi++;
	si[sipoi].x=-2;	si[sipoi].y=2;	si[sipoi].next=NULL;

	ldata* gfuto;
	for(y=2;y<SOR-2;y++)
		for(x=2;x<OSZ-2;x++)
			if(L[x][y]){
				for(m=0;m<16;m++){
					if((gfuto=L[ x+si[m].x ][ y+si[m].y ])&&(gfuto->graphord!=L[x][y]->graphord) ){
						gdata[ gfuto->graphord ].startpoint=NULL;
						L[x][y]->link[ L[x][y]->linknum++ ]=gfuto;
						gfuto->link[ gfuto->linknum++ ]=L[x][y];
						RenumberedNum=0;
						RenumberGraph(gfuto,L[x][y]->graphord);
						gdata[ gfuto->graphord ].num+=RenumberedNum;
					}
				}
			}

	delete[] si;

	//subgraph statistic sorting
	int van;
	for(m=0;m<gdatap;m++){
		van=1;
		while(van&&!gdata[m].startpoint){
			van=0;
			for(n=m;n<gdatap-1;n++){
				if(gdata[n+1].startpoint)van=1;
				gdata[n].startpoint=gdata[n+1].startpoint;
				gdata[n].num=gdata[n+1].num;
				gdata[n].graphnumber=gdata[n+1].graphnumber;
			}
		}
	}

	for(gdatap=0;gdatap<10000;gdatap++)
		if(!gdata[gdatap].startpoint)
			break;

	graphdata gtemp;
	van=1;
	while(van){
		van=0;
		for(m=0;m<gdatap-1;m++){
			if(!gdata[m].startpoint)break;
			if(gdata[m+1].num>gdata[m].num){
            	van=1;
				gtemp.graphnumber=gdata[m+1].graphnumber;
				gtemp.startpoint=gdata[m+1].startpoint;
				gtemp.num=gdata[m+1].num;
				gdata[m+1].graphnumber=gdata[m].graphnumber;
				gdata[m+1].startpoint=gdata[m].startpoint;
				gdata[m+1].num=gdata[m].num;
				gdata[m].graphnumber=gtemp.graphnumber;
				gdata[m].startpoint=gtemp.startpoint;
				gdata[m].num=gtemp.num;
			}
		}
	}

	//Delete too short graphs
	for(n=0;n<gdatap;n++){
		if(gdata[n].num<100)break;		//threshold
	}
	gdatap=n;

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			if(L[x][y]){
				van=0;
				for(m=0;m<gdatap;m++){
					if(L[x][y]->graphord==gdata[m].graphnumber)van=1;
				}
				if(!van){
					delete L[x][y];
					L[x][y]=NULL;
				}
			}

	//Eliminate noisy short branches
	ldata** spike=new(ldata*[2000]);
	int spikep=0;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y]&&(L[x][y]->linknum==1)){
				if(CountSpike(L[x][y])<MINGRAPHPOINTS)DeleteSpike(L[x][y]);
				else spike[spikep++]=L[x][y];
				if(spikep>1999){
					ShowMessage("ERROR spikep!");
					return;
				}
			}
		}
	delete[] spike;		//spike statistic - not used

	//Create LinkPairs - crosslinking
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y]&&(L[x][y]->linknum>2)){
				CreateLinkPairs(L[x][y]);
			}
		}


//	if(!enableCur)goto atug1;

//SEARCHING CONTINOUS LINES
//Line statistic
	cur=new (curves [10000]);
	curpoi=0;
//	int curpntpoi;
//	ldata* futo;
//	ldata* prev;
//	float th1,th2;
	for(z=0;z<10000;z++){
		cur[z].curvenum=z;
		cur[z].startpoint=NULL;
		cur[z].endpoint=NULL;
		cur[z].num=0;
		cur[z].points=NULL;
	}
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
//x=263;y=327;
			if(L[x][y]){
				for(z=0;z<L[x][y]->linknum;z++){
					if(L[x][y]->link[z]->CurveCluster>=0)continue;

					//create new cluster
					cur[curpoi].startpoint=L[x][y];
					cur[curpoi].endpoint=L[x][y];
					cur[curpoi].points=new(ldata*[1000]);
					for(w=0;w<1000;w++)	cur[curpoi].points[w]=NULL;

					if(ClusterizeSubCurve(L[x][y], L[x][y]->link[z], curpoi, 1)==-1){
						ShowMessage("ERROR: data integrity failed");
						return;
					}
					if(L[x][y]->linkpairs && L[x][y]->linkpairs[z]){
						if(ClusterizeSubCurve(L[x][y], *L[x][y]->linkpairs[z], curpoi, 2)==-1){
							ShowMessage("ERROR: data integrity failed");
							return;
						}
					}
					
					curpoi++;
					
					if(curpoi>9999){
						ShowMessage("ERROR curpoi overflow");
						return ;
					}
				}
			}

	//ordering curve points in point array
	for(z=0;z<10000;z++){
		if(cur[z].startpoint==NULL)break;
		if(cur[z].num){
			for(x=0;x<1000;x++){
				if(cur[z].points[x])break;
			}
			for(y=0;x<1000;x++){
				cur[z].points[y++]=cur[z].points[x];
				cur[z].points[x]=NULL;
			}
		}
	}

	//Sort curves
	curves** curp=new(curves*[10000]);
	curves* t_cp;
	for(z=0;z<10000;z++){
		curp[z]=&cur[z];
	}
	int csere=1;
	while(csere){
		csere=0;
		for(z=1;z<10000;z++){
			if(curp[z]->startpoint==NULL)break;
			if(curp[z-1]->num<curp[z]->num){
				csere=1;
				t_cp=curp[z-1];
				curp[z-1]=curp[z];
				curp[z]=t_cp;
			}
		}
	}

	goto atug1213;
	//delete short curves
	for(z=0;z<10000;z++)
		if((cur[z].num<20)&&(cur[z].num!=0)){	//threshold - curve min
			for(x=0;x<cur[z].num;x++){
				cur[z].points[x]->CurveCluster=-1;
			}
			cur[z].startpoint=NULL;
			cur[z].endpoint=NULL;
			cur[z].num=0;
			delete cur[z].points;
			cur[z].points=NULL;
		}
	atug1213:

	goto atug120;
	//delete too curly curves
	float avangle;
	int aboveavnum;
	for(z=1;z<10000;z++){
		if(curp[z]->startpoint==NULL)break;
		avangle=0.0;
		aboveavnum=0;
		for(x=0;x<curp[z]->num;x++){
			avangle+=curp[z]->points[x]->LocalAngle/(float)curp[z]->num;
		}
		for(x=0;x<curp[z]->num;x++){
			if(avangle==0.0)continue;
			if(  fabs(curp[z]->points[x]->LocalAngle-avangle)/avangle>0.2  ){//threshold
				aboveavnum++;
			}
		}
		if(aboveavnum!=0)
			if( fabs( ((float)curp[z]->num-(float)aboveavnum)/(float)aboveavnum ) > 0.2 ){
				//delete
				curp[z]->startpoint=NULL;
				curp[z]->endpoint=NULL;
				curp[z]->num=0;
				delete curp[z]->points;
				curp[z]->points=NULL;
			}
	}
	atug120:


/*	
//CUT LINES INTO SMALL SUBPARTS BY INCLINATION

//TEST
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			Image1->Canvas->Pixels[x][y]=0xFFFFFF;
	int X,Y;
	Image1->Canvas->Pen->Color=0xFF0000;
	for(z=1;z<10000;z++){
		if(curp[z]->startpoint==NULL)continue;
		X=curp[z]->startpoint->X;
		Y=curp[z]->startpoint->Y;
		Image1->Picture->Bitmap->Canvas->MoveTo(X,Y);
		for(x=0;x<curp[z]->num;x+=5){
			X=curp[z]->points[x]->X;
			Y=curp[z]->points[x]->Y;
			Image1->Picture->Bitmap->Canvas->LineTo(X,Y);
		}
		X=curp[z]->endpoint->X;
		Y=curp[z]->endpoint->Y;
		Image1->Picture->Bitmap->Canvas->LineTo(X,Y);
	}

	return;
*/



	//test draw
	//TEST
	//DRAW TEST
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			if(L[x][y]){
				inputkep[x][y]=0x000000;
				if(L[x][y]->linknum>2 )
					Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0x0000FF;
				else
					if(L[x][y]->CurveCluster==-1)
						Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0x8F8F8F;
					else
						Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0xE0E000;
			}else{
				Image1->Picture->Bitmap->Canvas->Pixels[x][y]=0xFFFFFF;
				inputkep[x][y]=0xFFFFFF;
			}

/*
//TEST
	//draw first 10 lines
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			Image1->Canvas->Pixels[x][y]=inputkep[x][y];
	for(z=0;z<10000;z++){
		if(curp[z]->startpoint==NULL)continue;
//		for(y=0;y<SOR;y++)
//			for(x=0;x<OSZ;x++)
//				Image1->Canvas->Pixels[x][y]=inputkep[x][y];
		for(x=0;x<curp[z]->num;x++){
			Image1->Canvas->Pixels[curp[z]->points[x]->X ][curp[z]->points[x]->Y ]=0x0000FF;
		}
//		ShowMessage("OK");
	}
*/

	//DELETE				
	if(cur){
		for(z=0;z<1000;z++){
			if(cur[z].points) delete[] cur[z].points;
		}
		delete[] cur;
	}

	atug1:
	delete[] gdata;
	delete[] curp;

}
//---------------------------------------------------------------------------


void __fastcall TForm8::Button7Click(TObject *Sender)
{
	Form10->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm8::mouseup(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	click=0;	
}
//---------------------------------------------------------------------------

int oldX=0;
int oldY=0;

void __fastcall TForm8::mousemove(TObject *Sender, TShiftState Shift, int X,
	  int Y)
{
	if(L==NULL)return;
	if(X>OSZ)return;
	if(Y>SOR)return;
	if(click){
    	if((X<0)||(Y<0))return;
		int x,y,q;
		int lx,ly;
		for(x=0;x<10;x++)
			for(y=0;y<10;y++){
				if((x+oldX>OSZ-1)||(y+oldY>SOR-1)||(x+oldX<0)||(y+oldY<0))return;
				if(!L[x+oldX][y+oldY])Image1->Picture->Bitmap->Canvas->Pixels[x+oldX][y+oldY]=0xFFFFFF;
			}
		for(x=0;x<10;x++)
			for(y=0;y<10;y++){
				if(!L[x+X][y+Y])Image1->Picture->Bitmap->Canvas->Pixels[x+X][y+Y]=0x5FFFFF;
				Form10->colors[x][y]=Image1->Picture->Bitmap->Canvas->Pixels[x+X][y+Y];
			}
		oldX=X;oldY=Y;
		Form10->refresh();

		//Thetas
		for(x=0;x<10;x++)
			for(y=0;y<10;y++){
				Form10->PutTheta(x,y,thetas[x+X][y+Y]);
			}
			
		//Connections
		for(x=0;x<10;x++)
			for(y=0;y<10;y++){
				for(q=0;q<10;q++){
					if(((x+X)<OSZ)&&((y+Y)<SOR)&&L[x+X][y+Y]&&L[x+X][y+Y]->link[q]){
						lx= x + L[x+X][y+Y]->link[q]->X - L[x+X][y+Y]->X ;
						ly= y + L[x+X][y+Y]->link[q]->Y - L[x+X][y+Y]->Y ;
						if((lx<0)||(ly<0)||(lx>9)||(ly>9))continue;
						Form10->connect(x,y,lx,ly);
					}
				}
			}

		Form10->XcoordZ=X;
		Form10->YcoordZ=Y;		
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm8::Prefilter()
{
	int** ori;	//Original picture
	int** res;	//resulted
	int x,y;
	int m,n;

	ori=new(int*[OSZ]);
	for(x=0;x<OSZ;x++)ori[x]=new(int[SOR]);

	res=new(int*[OSZ]);
	for(x=0;x<OSZ;x++)res[x]=new(int[SOR]);

	int c;

//pre filtering
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			c=Image1->Picture->Bitmap->Canvas->Pixels[x][y];
			ori[x][y]=(c&0xFF)/3+(c&0xFF00)/256/3+(c&0xFF0000)/256/256/3;
			res[x][y]=0;
		}

	int av;
	for(y=1;y<SOR-1;y++)
		for(x=1;x<OSZ-1;x++){
			av=0;
			for(n=-1;n<1;n++)
				for(m=-1;m<1;m++){
					av+=ori[x+m][y+n];
				}
			res[x][y]=av/9;
		}

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			ori[x][y]=res[x][y];
		}

	for(y=1;y<SOR-1;y++)
		for(x=1;x<OSZ-1;x++){
			av=0;
			for(n=-1;n<1;n++)
				for(m=-1;m<1;m++){
					av+=ori[x+m][y+n];
				}
			res[x][y]=av/9;
		}

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]= res[x][y]+res[x][y]*256+res[x][y]*256*256;
		}

	for(x=0;x<OSZ;x++)delete ori[x];
	delete ori;

	for(x=0;x<OSZ;x++)delete res[x];
	delete res;

}
//---------------------------------------------------------------------------

void __fastcall TForm8::Button8Click(TObject *Sender)
{
	Form11->Visible=true;
}
//---------------------------------------------------------------------------

//Point ambients: return 1 if there is a point in the ambient of the (x,y)
int __fastcall TForm8::PointAmb(int x,int y){
	if((x<1)||(y<1)||(x>OSZ-2)||(y>SOR-2))return 0;
	if(L[x][y])return 2;
	if((L[x+1][y])||(L[x-1][y])||(L[x][y+1])||(L[x][y-1])) return 1;
	if((L[x+1][y+1])||(L[x-1][y-1])||(L[x-1][y+1])||(L[x+1][y-1])) return 1;
	return 0;
}

//Point ambients : Signs the found points in the ambient of the point;
void __fastcall TForm8::PointAmbSign(int x,int y){
	if((x<1)||(y<1)||(x>OSZ-2)||(y>SOR-2))return;
	if(L[x][y]){
		L[x][y]->CurveCluster=1;
		return;
	}
	if(L[x+1][y])L[x+1][y]->CurveCluster=1;
	if(L[x-1][y])L[x-1][y]->CurveCluster=1;
	if(L[x][y+1])L[x][y+1]->CurveCluster=1;
	if(L[x][y-1])L[x][y-1]->CurveCluster=1;

	if(L[x+1][y+1])L[x+1][y+1]->CurveCluster=1;
	if(L[x-1][y-1])L[x-1][y-1]->CurveCluster=1;
	if(L[x-1][y+1])L[x-1][y+1]->CurveCluster=1;
	if(L[x+1][y-1])L[x+1][y-1]->CurveCluster=1;

}

void __fastcall TForm8::Button9Click(TObject *Sender)
{
//Generalized Hough transform - INIT

	Form11->Button3Click(NULL);
	float* R=Form11->R;
	float* Th=Form11->Th;
	int Size=Form11->pMAX;
	int HalfSize=Size/2;
	int Quarter1;	//addressing first quarter
	int Quarter3;	//addressing third quarter
	Quarter1=Size/4;
	Quarter3=HalfSize+Quarter1;

	int x,y;



	if(Sender){
		Image1->Picture->LoadFromFile("D:\\temp\\_inputkep.bmp");
		for(y=0;y<SOR;y++)
			for(x=0;x<OSZ;x++){
				inputkep[x][y]=Image1->Picture->Bitmap->Canvas->Pixels[x][y];
			}
	}else{
		Image1->Picture->LoadFromFile("D:\\temp\\Push-pull3.bmp");
		//CANNY
		Button2Click(Sender);
	}


	enableCur=0;
	Button6Click(NULL);
	enableCur=1;

//Generalized Hough transform - DO

	//count edge points
	int Noedge=0;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y]){
				Noedge++;
				L[x][y]->CurveCluster=0;	//CurveCluster redefine !  -will be a flag;
			}
		}

	ldata** Lref;
	Lref=new(ldata*[Noedge]);
	int pLref=0;

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y]) Lref[pLref++]=L[x][y];
		}

	struct TFtable{
		float mag;
		float turn;
		int Ox;
		int Oy;
		float fit;	//Fitting percentage - how much points
	};

	TFtable*Ftable=new(TFtable[10000]);
	int Fpoi=0;

	int w;
	int vx,vy;
	float tav;
	float tav_orig=tav_orig=R[0]+R[HalfSize];
	float mag;		//magnifying rate
	float turn;		//turning rate (rad)
	int Ox,Oy;		//reference origin
	int PointCnt;
	float fitLevel;
	int p;
	for(y=0;y<pLref;y++){
		for(x=0;x<pLref;x++){
			if(x==y)continue;
			if(Lref[x]->CurveCluster||Lref[y]->CurveCluster)continue;
			tav=sqrt( (float)pow2(Lref[x]->X-Lref[y]->X) + (float)pow2(Lref[x]->Y-Lref[y]->Y) );
			if((tav>20.0)&&(tav<400.0)){
				mag=tav/tav_orig;
				turn=AtanQuotient0360( Lref[y]->X-Lref[x]->X , Lref[y]->Y-Lref[x]->Y );

				Ox=Lref[x]->X+    (float)(Lref[y]->X-Lref[x]->X)/tav*mag*(float)R[HalfSize];
				Oy=Lref[x]->Y+    (float)(Lref[y]->Y-Lref[x]->Y)/tav*mag*(float)R[HalfSize];

				vx=Ox+R[Quarter1]*mag*cos(Th[Quarter1]+turn);
				vy=Oy+R[Quarter1]*mag*sin(Th[Quarter1]+turn);
				if(!PointAmb(vx,vy))
					continue;

				vx=Ox+R[Quarter3]*mag*cos(Th[Quarter3]+turn);
				vy=Oy+R[Quarter3]*mag*sin(Th[Quarter3]+turn);
				if(!PointAmb(vx,vy))
					continue;

				PointCnt=0;
				fitLevel=0.0;
				for(w=0;w<Size;w++){
					vx=Ox+R[w]*mag*cos(Th[w]+turn);
					vy=Oy+R[w]*mag*sin(Th[w]+turn);
					if(p=PointAmb(vx,vy)){
						PointCnt++;
						fitLevel+=(float)p/2.0;
					}
				}

				if(PointCnt>Size*0.8){	//threshold
					//FOUND
					Ftable[Fpoi].mag=mag;
					Ftable[Fpoi].turn=turn;
//					Ftable[Fpoi].Ox=Ox;
					Ftable[Fpoi].Oy=Oy;
					Ftable[Fpoi].fit=fitLevel/(float)Size;
					Fpoi++;
					if(Fpoi>9999){
						ShowMessage("ERROR Fpoi overflow");
						return;
					}
					for(w=0;w<Size;w++){
						vx=Ox+R[w]*mag*cos(Th[w]+turn);
						vy=Oy+R[w]*mag*sin(Th[w]+turn);
						//DRAW
//						Image1->Picture->Bitmap->Canvas->Pixels[vx][vy]=0x0000FF;

//test
//						PointAmbSign(vx,vy);
					}
				}

			}
		}
	}

	int csere=1;
	float TT;
	while(csere){
		csere=0;
		for(x=0;x<Fpoi-1;x++){
			if(Ftable[x].fit<Ftable[x+1].fit){
//			if(Ftable[x].mag < Ftable[x+1].mag){
				csere=1;
				TT=Ftable[x].mag;
				Ftable[x].mag=Ftable[x+1].mag;
				Ftable[x+1].mag=TT;
				TT=Ftable[x].turn;
				Ftable[x].turn=Ftable[x+1].turn;
				Ftable[x+1].turn=TT;
				TT=Ftable[x].fit;
				Ftable[x].fit=Ftable[x+1].fit;
				Ftable[x+1].fit=TT;
				y=Ftable[x].Ox;
				Ftable[x].Ox=Ftable[x+1].Ox;
				Ftable[x+1].Ox=y;
				y=Ftable[x].Oy;
				Ftable[x].Oy=Ftable[x+1].Oy;
				Ftable[x+1].Oy=y;
			}
		}
	}

	for(x=0;x<50;x++){	//Threshold - DRAW
		for(w=0;w<Size;w++){
			vx=Ftable[x].Ox+R[w]*Ftable[x].mag*cos(Th[w]+Ftable[x].turn);
			vy=Ftable[x].Oy+R[w]*Ftable[x].mag*sin(Th[w]+Ftable[x].turn);
			Image1->Picture->Bitmap->Canvas->Pixels[vx][vy]=0x0000FF;
		}
	}




	delete[] Ftable;
	delete[] Lref;

}
//---------------------------------------------------------------------------

//Put a cross to the place of the pixel
void TForm8::MarkPixel(int x,int y,int color){
	if((x<1)||(y<1))return;
	if((x>OSZ-2)||(y>SOR-2))return;

	Image1->Picture->Bitmap->Canvas->Pixels[x][y]=color;
	Image1->Picture->Bitmap->Canvas->Pixels[x+1][y]=color;
	Image1->Picture->Bitmap->Canvas->Pixels[x-1][y]=color;
	Image1->Picture->Bitmap->Canvas->Pixels[x][y+1]=color;
	Image1->Picture->Bitmap->Canvas->Pixels[x][y-1]=color;

}
void __fastcall TForm8::Button10Click(TObject *Sender)
{
	//Do recognize for picture
	Button9Click(NULL);		
}
//---------------------------------------------------------------------------

//2D FFT
void __fastcall TForm8::Button11Click(TObject *Sender)
{
	//2D FFT
//	Image1->Picture->LoadFromFile("D:\\temp\\_inputkep.bmp");
//	Image1->Picture->LoadFromFile("D:\\temp\\Push-pull3.bmp");
	int x,y,c;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			c=Image1->Picture->Bitmap->Canvas->Pixels[x][y];
			inputkep[x][y]=(c&0xFF)/3+(c&0xFF00)/256/3+(c&0xFF0000)/256/256/3;
			BWkep[x][y]=inputkep[x][y]+inputkep[x][y]*256+inputkep[x][y]*256*256;
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=BWkep[x][y];
		}

	float incr=0.0;
	for(x=0;x<20;x++){
		for(y=0;y<SOR;y++){
			inputkep[x][y]=(int)((float)inputkep[x][y]*incr);
		}
		incr+=0.05;
	}
	incr=1.0;
	for(x=OSZ-20;x<OSZ;x++){
		for(y=0;y<SOR;y++){
			inputkep[x][y]=(int)((float)inputkep[x][y]*incr);
		}
		incr-=0.05;
	}

	incr=0.0;
	for(y=0;y<20;y++){
		for(x=0;x<OSZ;x++){
			inputkep[x][y]=(int)((float)inputkep[x][y]*incr);
		}
		incr+=0.05;
	}
	incr=1.0;
	for(y=SOR-20;y<SOR;y++){
		for(x=0;x<OSZ;x++){
			inputkep[x][y]=(int)((float)inputkep[x][y]*incr);
		}
		incr-=0.05;
	}

/*
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=inputkep[x][y]+inputkep[x][y]*256+inputkep[x][y]*256*256;
	return;
*/

	COMPLEX **C;
	C=new(COMPLEX*[512]);
	for(x=0;x<OSZ;x++)C[x]=new(COMPLEX[512]);

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			C[x][y].real=0;
			C[x][y].imag=0;
		}

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			C[x][y].real=inputkep[x][y];
			C[x][y].imag=0;
		}

	int res=FFT2D(C,512,512,1);
	if(!res){
		ShowMessage("ERROR");
		return;
	}


	float** T;
	T=new(float*[512]);
	for(x=0;x<512;x++)T[x]=new(float[512]);

	float min, max;
	min=max=C[100][100].real;
	for(y=0;y<512;y++)
		for(x=0;x<512;x++){
			T[x][y]=fabs(C[x][y].real);
//			if(T[x][y]<0.0)T[x][y]=0.0;
/*
			if(x<2){
				T[x][y]=0;
				continue;
			}
			if(x>510){
				T[x][y]=0;
				continue;
			}
			if(y<2){
				T[x][y]=0;
				continue;
			}
			if(y>510){
				T[x][y]=0;
				continue;
			}
*/
			if(T[x][y]>max)max=T[x][y];
			if(T[x][y]<min)min=T[x][y];
		}

	max=min=log10(T[100][100]+0.001);
	for(y=0;y<512;y++)
		for(x=0;x<512;x++){
			T[x][y]=log10(T[x][y]+0.001);
			if(T[x][y]>max)max=T[x][y];
			if(T[x][y]<min)min=T[x][y];
		}

	for(y=0;y<512;y++)
		for(x=0;x<512;x++){
			T[x][y]=(T[x][y]-min)/(max-min)*255.0;
//			T[x][y]=(T[x][y]-min)/(max-min)*0xFFFFFF;
//			T[x][y]=(T[x][y]*100-50)*10;
		}

	float temp;
	for(y=0;y<256;y++){
		for(x=0;x<256;x++){
			temp=T[x][y];
			T[x][y]=T[x+256][y+256];
			T[x+256][y+256]=temp;
		}
	}
	for(y=0;y<256;y++){
		for(x=256;x<512;x++){
			temp=T[x][y];
			T[x][y]=T[x-256][y+256];
			T[x-256][y+256]=temp;
		}
	}

//GAUSS
	int gaussop[5][5]={
		2,4,5,4,2,
		4,9,12,9,4,
		5,12,15,12,5,
		4,9,12,9,4,
		2,4,5,4,2
	};
	int m,n;
	float t;
	for(y=2;y<SOR-2;y++)
		for(x=2;x<OSZ-2;x++){
			t=0;
			for(m=-2;m<3;m++)
				for(n=-2;n<3;n++)
					t+=T[x+m][y+n]*gaussop[m+2][n+2]/130.0;
			T[x][y]=t;
		}

	//CUT
	for(y=2;y<SOR-2;y++)
		for(x=2;x<OSZ-2;x++){
			if(T[x][y]<100.0)T[x][y]=0.0;
//			else T[x][y]=255;
		}


	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=(int)T[x][y]+(int)T[x][y]*256+(int)T[x][y]*256*256;
//			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=(int)T[x][y]*3;
		}

	float R=20.0;
	float pi=3.14;
	float fi;
	float peaks[360][20];
	int cnt=0;
	int cnt2;
	for(cnt2=0;cnt2<20;cnt2++){
		cnt=0;
		for(fi=0.0;fi<2.0*pi;fi+=2.0*pi/360.0){
			peaks[cnt++][cnt2]=T[int(R*sin(fi))+256][int(R*cos(fi))+256];
			Image1->Picture->Bitmap->Canvas->Pixels[R*sin(fi)+256][R*cos(fi)+256]=0x0000FF;
		}
		R+=5.0;
	}

	char P[360][20];
	for(y=0;y<20;y++)
		for(x=0;x<360;x++)
			P[x][y]=0;
	Canvas->Pen->Color=0x00FF00;

	for(y=0;y<20;y++)
		for(x=0;x<360;x++){

			if(peaks[x][y]>0.0)		P[x][y]=1;

/*
			if(x==0){
				if((peaks[x][y]>peaks[359][y])&&(peaks[x][y]>peaks[x+1][y]))P[x][y]=1;
			}
			if(x==359){
				if((peaks[x][y]>peaks[0][y])&&(peaks[x][y]>peaks[x-1][y]))P[x][y]=1;
			}
			if((peaks[x][y]>peaks[x+1][y])&&(peaks[x][y]>peaks[x-1][y]))P[x][y]=1;

			if(P[x][y])Image1->Picture->Bitmap->Canvas->Pixels[10*y*sin((float)x/360.0*2.0*pi)+256][10*y*cos((float)x/360.0*2.0*pi)+256]=0x00FF00;
*/

		}
	char allok[360];
	for(x=0;x<360;x++){
		allok[x]=1;
		for(y=0;y<20;y++){
			if(!P[x][y])allok[x]=0;
		}
	}
	int X,Y;
	Image1->Picture->Bitmap->Canvas->Pen->Color=0x00FF00;
	for(x=0;x<360;x++){
		Image1->Picture->Bitmap->Canvas->MoveTo(256,256);
		X=100*sin((float)x/360.0*2.0*pi)+256;
		Y=100*cos((float)x/360.0*2.0*pi)+256;
		if(allok[x])
			Image1->Picture->Bitmap->Canvas->LineTo(X,Y);
	}

/*
	FILE*f;
	f=fopen("d:\\temp\\data.txt","w");
	for(x=0;x<20;x++){
		for(y=0;y<360;y++){
			fprintf(f,"%f ",peaks[y][x]);
		}
		fprintf(f,"\n");
	}
	fclose(f);
*/

/*
	FILE*f;
	f=fopen("d:\\temp\\data.txt","w");
	for(y=0;y<512;y++){
		for(x=0;x<512;x++){
			fprintf(f,"%f ",T[x][y]);
		}
		fprintf(f,"\n");
	}
	fclose(f);
*/

	for(x=0;x<512;x++)delete[] T[x];
	delete[] C;

	for(x=0;x<OSZ;x++)delete[] C[x];
	delete[] C;
}
//---------------------------------------------------------------------------

//COLOR BLOOB
void __fastcall TForm8::Button12Click(TObject *Sender)
{
//COLOR BLOOB
	int x,y;
/*
	Image1->Picture->LoadFromFile("D:\\temp\\Push-pull3.bmp");
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			inputkep[x][y]=Image1->Picture->Bitmap->Canvas->Pixels[x][y];
*/
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			inputkep[x][y]=OriKep[x][y];

			

	float hossz;
	float fakt;
	int r,g,b;
	float R,G,B;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			r=inputkep[x][y]&0xFF;
			g=(inputkep[x][y]&0xFF00)>>8;
			b=(inputkep[x][y]&0xFF0000)>>16;
			R=r;B=b;G=g;
			hossz=sqrt(R*R+G*G+B*B);
			if(hossz<10.0)inputkep[x][y]=0;
			else{
				fakt=300.0/hossz;
				R=R*fakt;
				G=G*fakt;
				B=B*fakt;

				if(R>255.0)R=255.0;
				if(G>255.0)G=255.0;
				if(B>255.0)B=255.0;


				if(R<32.0)R=0.0;
				else if((R>=32.0)&&(R<96.0))R=64.0;
				else if((R>=96.0)&&(R<160.0))R=128.0;
				else if((R>=160.0)&&(R<224.0))R=192.0;
				else if(R>=224.0)R=255.0;												

				if(G<32.0)G=0.0;
				else if((G>=32.0)&&(G<96.0))G=64.0;
				else if((G>=96.0)&&(G<160.0))G=128.0;
				else if((G>=160.0)&&(G<224.0))G=192.0;
				else if(G>=224.0)G=255.0;

				if(B<32.0)B=0.0;
				else if((B>=32.0)&&(B<96.0))B=64.0;
				else if((B>=96.0)&&(B<160.0))B=128.0;
				else if((B>=160.0)&&(B<224.0))B=192.0;
				else if(B>=224.0)B=255.0;


/*
				if(R>128.0)R=255.0;
				else R=0.0;
				if(G>128.0)G=255.0;
				else G=0.0;
				if(B>128.0)B=255.0;
				else B=0.0;
*/

				r=R;g=G;b=B;
				inputkep[x][y]=r+g*256+b*256*256;
			}
		}

	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			inputkep[x][y]=inputkep[x][y]&0xFCFCFC;

		}
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(Image1->Picture->Bitmap->Canvas->Pixels[x][y]==0xFFFFFF)
				Image1->Picture->Bitmap->Canvas->Pixels[x][y]=inputkep[x][y];
		}
}
//---------------------------------------------------------------------------

//Do ALL Color bloob
void __fastcall TForm8::Button13Click(TObject *Sender)
{
	//Do ALL Color bloob
	Button5Click(NULL);
	Button12Click(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TForm8::Button14Click(TObject *Sender)
{
//Blob staistic based search
	Image1->Picture->LoadFromFile("D:\\temp\\Push-pull3.bmp");

	int x,y,c;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			c=Image1->Picture->Bitmap->Canvas->Pixels[x][y];
			inputkep[x][y]=(c&0xFF)/3+(c&0xFF00)/256/3+(c&0xFF0000)/256/256/3;
			BWkep[x][y]=inputkep[x][y]+inputkep[x][y]*256+inputkep[x][y]*256*256;
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=BWkep[x][y];
		}

	float sum[SOR];
	for(y=0;y<SOR;y++){
		sum[y]=0.0;
		for(x=0;x<OSZ;x++){
			sum[y]+=(float)inputkep[x][y]/(float)OSZ;
		}
	}

	float sum2[OSZ];
	for(x=0;x<OSZ;x++){
		sum2[x]=0.0;
		for(y=0;y<SOR;y++){
			sum2[x]+=(float)inputkep[x][y]/(float)SOR;
		}
	}

	Image1->Picture->Bitmap->Canvas->Pen->Color=0x0000FF;	
	for(x=1;x<OSZ-1;x++){
		if((sum2[x]>sum2[x+1])&&(sum2[x]>sum2[x-1])){
			Image1->Picture->Bitmap->Canvas->MoveTo(x,0);
			Image1->Picture->Bitmap->Canvas->LineTo(x,SOR);
		}
	}
	for(x=1;x<SOR-1;x++){
		if((sum[x]>sum[x+1])&&(sum[x]>sum[x-1])){
			Image1->Picture->Bitmap->Canvas->MoveTo(0,x);
			Image1->Picture->Bitmap->Canvas->LineTo(OSZ,x);
		}
	}

	FILE*f;
	f=fopen("d:\\temp\\data.txt","w");
	for(x=0;x<OSZ;x++){
		fprintf(f,"%f ",sum2[x]);
	}
//	fprintf(f,"\n");
	fclose(f);
	ShowMessage("OK");
}
//---------------------------------------------------------------------------

//Hough Do all
void __fastcall TForm8::Button15Click(TObject *Sender)
{
	Image1->Picture->LoadFromFile("D:\\temp\\Push-pull3.bmp");
	Button2Click(NULL);//CANNY
	Button6Click(NULL);//DETECT2
//	Button3Click(NULL);//HOUGH
//	Button16Click(NULL);//HOUGH2
	HeuristicLineDet();//Heuristic line detection
}
//---------------------------------------------------------------------------

//Hough transform version 2
void __fastcall TForm8::Button16Click(TObject *Sender)
{

//Hough transform version 2

	int x,y,z;
	int X,Y;
	float theta,radius;

/*
//TEST
	Image1->Picture->LoadFromFile("d:\\temp\\testline.bmp");
	for(Y=0;Y<SOR;Y++)
		for(X=0;X<OSZ;X++)
			if(Image1->Canvas->Pixels[X][Y]==0)inputkep[X][Y]=0;
			else inputkep[X][Y]=1;
*/


//Memory
	if(stat){
		for(x=0;x<12;x++)delete[] stat[x];
		delete[] stat;
	}
	stat=new(linestat*[12]);
	for(x=0;x<12;x++)stat[x]=new(linestat[200]);

	int pstatord=0;
	int classcnt=0;

	for(x=0;x<12;x++)
		for(y=0;y<200;y++){
			stat[x][y].theta =(float)x*PI/12.0;
			stat[x][y].radius=(float)y*10.0-520.0;
			stat[x][y].num=0;
			stat[x][y].fuzzynum=0.0;
			stat[x][y].xcoord=x;
			stat[x][y].ycoord=y;
			stat[x][y].lineclass=classcnt++;
			statord[pstatord++] =&stat[x][y];
			for(z=0;z<OSZ;z++){
				stat[x][y].points[z]=NULL;
			}
		}

	if(H){
		for(y=0;y<SOR;y++)
			for(x=0;x<OSZ;x++)
				if(H[x][y])
					delete H[x][y];
		for(x=0;x<OSZ;x++)delete[] H[x];
		delete[] H;
	}
	
	H=new(hough**[OSZ]);
	for(x=0;x<OSZ;x++)H[x]=new(hough*[SOR]);
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++)
			if(!inputkep[x][y]){
				H[x][y]=new(hough);
				H[x][y]->theta =(thetas[x][y]>0.0)?thetas[x][y]:thetas[x][y]+PI;
				H[x][y]->radius=(float)y*cos(H[x][y]->theta)-(float)x*sin(H[x][y]->theta);
				H[x][y]->lineclass=0;
				H[x][y]->lineclasspoi=NULL;
				H[x][y]->X=x;
				H[x][y]->Y=y;
			}else
				H[x][y]=NULL;

//Statistic
int elso_=1;
	int xcoord,ycoord;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
/*
		if(elso_){
			elso_=0;
			x=263;y=327;
		}
*/


			if(!inputkep[x][y]){
				for(xcoord=0;xcoord<12;xcoord++){
					theta=stat[xcoord][0].theta;

//					//test
//					theta=thetas[x][y]+PI/2.0;
//					xcoord=theta/PI*11;


					radius=(float)y*cos(theta)-(float)x*sin(theta);
					//class coordinates
					ycoord=(int)((radius+520.0)/10.0);
					stat[xcoord][ycoord].points[ stat[xcoord][ycoord].num++ ]=H[x][y];
					H[x][y]->lineclass=stat[xcoord][ycoord].lineclass;

/*
					for(X=0;X<OSZ;X++){
						Y=(float)X*tan(stat[xcoord][ycoord].theta)+stat[xcoord][ycoord].radius/cos(stat[xcoord][ycoord].theta);
//						Y=(float)X*tan(theta)+radius/cos(theta);
						Image1->Canvas->Pixels[X][Y]=0xFF0000;
					}
					
					AnsiString mess;
					float hiba= (theta==0.0)?0.0: fabs(stat[xcoord][ycoord].theta-theta)/theta;
					float hiba2=(radius==0.0)?0.0: fabs(stat[xcoord][ycoord].radius-radius)/radius;
					mess.sprintf("TH=%.2f RD=%.2f",hiba,hiba2);
					ShowMessage(mess);
*/

				}
/*
ShowMessage("OK");


	//DRAW TEST
	for(Y=0;Y<SOR;Y++)
		for(X=0;X<OSZ;X++)
			Image1->Canvas->Pixels[X][Y]=inputkep[X][Y];
*/



			}
		}


//return;

//buborek for stat
	int csere=1;
	linestat* tmp;
	while(csere){
		csere=0;
		for(z=0;z<STATORDMAX-1;z++){
			if(statord[z]->num < statord[z+1]->num ){
				tmp=statord[z];
				statord[z]=statord[z+1];
				statord[z+1]=tmp;
				csere=1;
			}
		}
	}

//TEST
/*
	FILE*f;
	f=fopen("d:\\temp\\data.txt","w");
	for(y=0;y<200;y++){
		for(x=0;x<12;x++){
			fprintf(f,"%d ",stat[x][y].num);
		}
		fprintf(f,"\n");
	}
	fclose(f);
*/

//TEST DRAW LINES
	//Redraw edge picture to BW pic.
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=inputkep[x][y];
		}

	Image1->Picture->Bitmap->Canvas->Pen->Color=0x00FF00;
	int elso;
	for(z=0;z<20;z++){  		//first 20 lines in order

/*
		for(y=0;y<SOR;y++)
			for(x=0;x<OSZ;x++){
				Image1->Picture->Bitmap->Canvas->Pixels[x][y]=inputkep[x][y];
			}
*/

		elso=1;
		for(x=0;x<OSZ;x++){
			y=(float)x*tan(statord[z]->theta)+statord[z]->radius/cos(statord[z]->theta);
			if((y>0)&&(y<SOR)){
				if(elso){
					elso=0;
					Image1->Picture->Bitmap->Canvas->MoveTo(x,y);
				}else{
					Image1->Picture->Bitmap->Canvas->LineTo(x,y);
				}
			}
		}
		for(x=0;x<statord[z]->num;x++){
			Image1->Picture->Bitmap->Canvas->Pixels[ statord[z]->points[x]->X ][ statord[z]->points[x]->Y ]=0x0000FF;
		}


//		ShowMessage("OK");



	}

}
//---------------------------------------------------------------------------

//Heuristic Line Detection
void __fastcall TForm8::HeuristicLineDet(){

	int x,y;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=inputkep[x][y];
		}


	//allocate
	int linep=0;
	lines line[500];
	for(x=0;x<500;x++){
		line->num=0;
		line->lpoints=new( ldata*[OSZ] );
		for(y=0;y<OSZ;y++)line->lpoints[x]=NULL;
	}
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(L[x][y])L[x][y]->CurveCluster=-1;
		}

	//clusterize
	int X,Y;
	float m;
	float theta;
	int rx=0;
	int vy;
	int exit=0;
	char cont;
	char van;
	ldata* ol;
	int pDB=0;
	lines lineDB[2000];
	lines tl;
	tl.lpoints=new( ldata*[OSZ] );

	int direction=1;

	//heuristic search
	for(Y=0;Y<SOR;Y++)for(X=0;X<OSZ;X++){

//	for(Y=298;Y<299;Y++)for(X=92;X<93;X++){//}
//	for(Y=334;Y<335;Y++)for(X=239;X<240;X++){//}

		if(L[X][Y]==NULL)continue;
		if(L[X][Y]->CurveCluster!=-1)continue;

		tl.num=0;
		tl.lpoints[tl.num++]=L[X][Y];
		ol=L[X][Y]->link[0];
		cont=0;

		rx=0;
		exit=0;
		direction=1;

		//invalid point
		if((incl[X][Y].dy==0) && (incl[X][Y].dx==0))
			continue;

		tl.start=L[X][Y];
		tl.end=L[X][Y];		

		//seprated by inclination part 1
		if(abs(incl[X][Y].dy) < abs(incl[X][Y].dx)){
			for(x=X;(x<OSZ)&&(x>=0);(direction)?x++:x--){
				m=(float)incl[X][Y].dy/(float)incl[X][Y].dx;
				y=(int)(m*(float)rx)+Y;
				rx++;
				van=0;
				for(vy=-2;vy<3;vy++){
					if((x<0)||(x>OSZ-1)||(y+vy<0)||(y+vy>SOR-1))continue;
					if(L[x][y+vy]){
						van=1;
						if((L[x][y+vy]->link[0]==ol)||(L[x][y+vy]->link[1]==ol)||(L[x][y+vy]->link[2]==ol)||cont){
							ol=L[x][y+vy];
							tl.lpoints[tl.num++]=ol;
							tl.start=ol;
							break;
						}else{
							exit=1;
							break;
						}
					}
				}
			}
			
			if(van)cont=0;
			else{
				if(cont)exit=1;
				else cont=1;
			}
			if(direction){
				if(exit||(x>OSZ-2)){
					direction=0;
					rx=0;
					exit=0;
					ol=L[X][Y]->link[0];
					cont=0;
				}
			}else{
				if(exit){
					break;
				}
			}
		}else{
		//seprated by inclination part 2
			for(y=Y;(y<SOR)&&(y>=0);(direction)?y++:y--){
				m=(float)incl[X][Y].dx/(float)incl[X][Y].dy;
				x=(m*(float)rx)+X;
				rx++;
				van=0;
				for(vy=-2;vy<3;vy++){
					if((x+vy<0)||(x+vy>OSZ-1)||(y<0)||(y>SOR-1))continue;
					if(L[x+vy][y]){
						van=1;
						if((L[x+vy][y]->link[0]==ol)||(L[x+vy][y]->link[1]==ol)||(L[x+vy][y]->link[2]==ol)||cont){
							ol=L[x+vy][y];
							tl.lpoints[tl.num++]=ol;
							tl.end=ol;							
							break;
						}else{
							exit=1;
							break;
						}
					}
				}
			}
			
			if(van)cont=0;
			else{
				if(cont)exit=1;
				else cont=1;
			}
			if(direction){
				if(exit||(x>OSZ-2)){
					direction=0;
					rx=0;
					exit=0;
					ol=L[X][Y]->link[0];
					cont=0;
				}
			}else{
				if(exit){
					break;
				}
			}
		}


		//Line threshold - delete too short curve
		int tnum;
		int sx;
		int megvan;
		if(tl.num<5){//threshold
			for(x=0;x<tl.num;x++)
				tl.lpoints[x]->CurveCluster=-1;
		}else{	//else copy into line database
			lineDB[pDB].lpoints=new( ldata*[OSZ] );
			lineDB[pDB].ord=pDB;
			lineDB[pDB].num=0;
			if(incl[X][Y].dx!=0)
				m=(float)incl[X][Y].dy/(float)incl[X][Y].dx;
			else
				m=10000.0;
			lineDB[pDB].m=m;
			lineDB[pDB].b=(float)Y-m*(float)X;
			lineDB[pDB].start=tl.start;
			lineDB[pDB].end=tl.end;

			//check subset curves  and copy
			for(x=0;x<tl.num;x++){
				if(tl.lpoints[x]->CurveCluster!=-1){
					if(tl.lpoints[x]->CurveCluster==pDB)continue;
					if( lineDB[ tl.lpoints[x]->CurveCluster ].num < tl.num ){
						//delete point from shorter line
						tnum=tl.lpoints[x]->CurveCluster;
						megvan=0;
						for(sx=0;sx<lineDB[ tnum ].num;sx++ ){
							if(!megvan){
								if(lineDB[ tnum ].lpoints[ sx ] == tl.lpoints[x] ){
									megvan=1;
								}
							}else{
								lineDB[ tnum ].lpoints[ sx-1 ]=lineDB[ tnum ].lpoints[ sx ];
							}
						}
						if(megvan)
							lineDB[ tnum ].num--;
					}else{
						//delete point from shorter line (from tl)
						continue;
					}
					//copy tl to lineDB
					lineDB[pDB].lpoints[ lineDB[pDB].num++ ]=tl.lpoints[x];
					tl.lpoints[x]->CurveCluster=pDB;
					if(lineDB[pDB].num>OSZ-1)
						ShowMessage("ERR");
				}else{
					lineDB[pDB].lpoints[ lineDB[pDB].num++ ]=tl.lpoints[x];
					tl.lpoints[x]->CurveCluster=pDB;
					if(lineDB[pDB].num>OSZ-1)
						ShowMessage("ERR");
				}
			}
			pDB++;

		}

	}


	//recalculate m and b line parameters using start and end points
	ldata* tempP;	
	for(x=0;x<pDB;x++){
		if(lineDB[x].num==0 )continue;
		if(lineDB[x].start==lineDB[x].end)continue;

//		if(lineDB[x].m>=10000.0 )continue;
//		if(fabs(lineDB[x].m)<1.0)continue;

		if(lineDB[x].start->X == lineDB[x].end->X ){
			lineDB[x].m=10000.0;
		}else{
			lineDB[x].m=(float)(lineDB[x].start->Y - lineDB[x].end->Y)/(float)(lineDB[x].start->X - lineDB[x].end->X);
		}
		lineDB[x].b=(float)lineDB[x].start->Y - lineDB[x].m * (float)lineDB[x].start->X;

	}

	//Concatenate Lines
	int z;
	int tDB;
	for(x=0;x<pDB;x++){
		for(y=0;y<2;y++ ){
			for(z=0;z< ((!y)? lineDB[x].start->linknum : lineDB[x].end->linknum) ;z++ ){
				if( (tDB= (!y)? lineDB[x].start->link[z]->CurveCluster : lineDB[x].end->link[z]->CurveCluster) != x ){
					if((tDB<0)||(tDB>pDB-1)){
//						ShowMessage("ERROR 545555");
						continue;
					}
					if(
						fabs((lineDB[tDB].m - lineDB[x].m)/  ( ((lineDB[x].m==0.0)&&(lineDB[tDB].m==0.0)) ? 0.1 : ((lineDB[x].m!=0.0)?lineDB[x].m:lineDB[tDB].m) ) )<0.2 &&	//threshold
						fabs((lineDB[tDB].b - lineDB[x].b)/  ( ((lineDB[x].b==0.0)&&(lineDB[tDB].b==0.0)) ? 0.1 : ((lineDB[x].b!=0.0)?lineDB[x].b:lineDB[tDB].b) ) )<0.2   	//threshold
					  ){
						//concatenate
						if(lineDB[x].num+lineDB[tDB].num>OSZ-2){
							ShowMessage("ERROR 12345");
							continue;
						}
						for(X=0;X<lineDB[tDB].num;X++ ){
							lineDB[x].lpoints[ lineDB[x].num ]=lineDB[tDB].lpoints[X];
							lineDB[x].lpoints[ lineDB[x].num++ ]->CurveCluster=x;
						}
						lineDB[x].m=(lineDB[x].m+lineDB[tDB].m)/2.0;
						lineDB[x].b=(lineDB[x].b+lineDB[tDB].b)/2.0;

						if(!y)
							lineDB[x].start=lineDB[tDB].start;
						else
							lineDB[x].end=lineDB[tDB].end;

						lineDB[x].start->CurveCluster=x;
						lineDB[x].end->CurveCluster=x;						

//						delete [] lineDB[tDB].lpoints;
//						lineDB[tDB].lpoints=NULL;
						lineDB[tDB].num=0;
					  }
				}
			}
		}
	}


	//Ordering
	lines* PlineDB[2000];
	lines* Ptmp;
	for(x=0;x<2000;x++){
		PlineDB[x]=NULL;
	}
	for(x=0;x<pDB;x++){
		PlineDB[x]=&lineDB[x];
	}
	int csere=1;
	while(csere){
		csere=0;
		for(x=0;x<pDB-1;x++){
			if( (*PlineDB[x]).num < (*PlineDB[x+1]).num ){
				csere=1;
				Ptmp=PlineDB[x];
				PlineDB[x]=PlineDB[x+1];
				PlineDB[x+1]=Ptmp;
			}
		}
	}


	//Draw found lines
	Image1->Picture->Bitmap->Canvas->Pen->Color=0x00FF00;
	Image1->Picture->Bitmap->Canvas->MoveTo(0,0);

/*
//	for(x=0;x<pDB;x++){
	for(x=0;x<10;x++){
//	for(x=0;x<0;x++){
//}
//}
		if((*PlineDB[x]).num==0 )continue;


		for(X=0;X<OSZ;X++){
			if(X==0)
				Image1->Picture->Bitmap->Canvas->MoveTo( X , (*PlineDB[x]).m*(float)X+(*PlineDB[x]).b );
			else
				Image1->Picture->Bitmap->Canvas->LineTo( X , (*PlineDB[x]).m*(float)X+(*PlineDB[x]).b );
		}


		for(y=0; y<(*PlineDB[x]).num; y++ ){
			Image1->Picture->Bitmap->Canvas->Pixels[ (*PlineDB[x]).lpoints[y]->X ][ (*PlineDB[x]).lpoints[y]->Y ]=0x0000FF;
		}

		Image1->Picture->Bitmap->Canvas->Pixels[ (*PlineDB[x]).start->X ][ (*PlineDB[x]).start->Y ]=0x00FF00;
		Image1->Picture->Bitmap->Canvas->Pixels[ (*PlineDB[x]).end->X ][ (*PlineDB[x]).end->Y ]=0xFF0000;
	}
*/

//VONAL SZOMSZEDOSSAG KERESES
//VONALSZOMSZEDOSSAGI GRAF

	struct LineNeighbour{
		lines* owner;	//node owner line
		int ordnum;		//ordinary number of line in ordered LineDB
		LineNeighbour* link[10];
		int linknum;
	};

    //init
	LineNeighbour* LN=new(LineNeighbour[pDB]);
	for(x=0;x<pDB;x++){
		LN[x].owner=&lineDB[x];
		LN[x].ordnum=x;
		LN[x].linknum=0;
		for(y=0;y<10;y++)
			LN[x].link[y]=NULL;
	}

	//szomszedkereses
	int ox,oy;
	for(x=0;x<pDB;x++){
		int m,n;
		int van=0;

		ox=LN[x].owner->start->X;
		oy=LN[x].owner->start->Y;
		for(m=ox-5;m<ox+5;m++)
			for(n=oy-5;n<oy+5;n++){
				if((n<0)||(m<0)||(n>=SOR)||(m>=OSZ))
					continue;
				if(L[m][n])
					if(L[m][n]->CurveCluster!=LN[x].owner->ord ){
						van=0;
						for(z=0;z<LN[x].linknum;z++ )
							if(L[m][n]->CurveCluster == LN[x].link[z]->owner->ord )	van=1;
						//belinkeles
						if(van)continue;
						if(LN[x].linknum >=10)continue;
						if(L[m][n]->CurveCluster<0)continue;
						LN[x].link[ LN[x].linknum++ ] = &LN[ L[m][n]->CurveCluster ];
					}
			}

		ox=LN[x].owner->end->X;
		oy=LN[x].owner->end->Y;
		for(m=ox-5;m<ox+5;m++)
			for(n=oy-5;n<oy+5;n++){
				if((n<0)||(m<0)||(n>=SOR)||(m>=OSZ))
					continue;
				if(L[m][n])
					if(L[m][n]->CurveCluster!=LN[x].owner->ord ){
						van=0;
						for(z=0;z<LN[x].linknum;z++ )
							if(L[m][n]->CurveCluster == LN[x].link[z]->owner->ord )	van=1;
						//belinkeles
						if(van)continue;
						if(LN[x].linknum >=10)continue;
						if(L[m][n]->CurveCluster<0)continue;						
						LN[x].link[ LN[x].linknum++ ] = &LN[ L[m][n]->CurveCluster ];
					}
			}

	}

/*	
	goto a1_1;
	//SECONDARY CONNECT-LINE ALGORITHM
//	ROSSZ ! CurveCluster osszekavarodott az elozo concatenate miatt + start es end pointok nincsenek allitva 
	float M1,M2,B1,B2;
	for(x=0;x<pDB;x++){
		if(LN[x].owner==NULL )continue;
		for(z=0;z<LN[x].linknum;z++ ){
			M1=LN[x].owner->m;
			M2=LN[x].link[z]->owner->m;
			B1=LN[x].owner->b;
			B2=LN[x].link[z]->owner->b;
			if(
				fabs(( M1 - M2 )/  ( ((M1==0.0)&&(M2==0.0)) ? 0.1 : ((M1!=0.0)?M1:M2) ) )<0.2 &&	//threshold
				fabs(( B1 - B2 )/  ( ((B1==0.0)&&(B2==0.0)) ? 0.1 : ((B1!=0.0)?B1:B2) ) )<0.2   	//threshold
			){
				//concatenate
				//1.link together
				//2.delete line from ordinary list
				//3.delete line from neighbourhood graph
				int NUM;
				int w;
				for(y=0;y<LN[x].link[z]->owner->num;y++ ){ //OSZ
					NUM=LN[x].owner->num;
					LN[x].owner->lpoints[NUM]=LN[x].link[z]->owner->lpoints[y];
					NUM++;
					if(NUM>=OSZ){
						ShowMessage("ERROR OVFL_01");
						continue;
					}
					LN[x].owner->num=NUM;
				}
				LN[x].link[z]->owner->num=0;
				//delete from neighbourhood graph
				LN[x].link[z]->owner=NULL;
				for(y=z;y<9;y++){
					LN[x].link[y]=LN[x].link[y+1];
				}
				LN[x].link[9]=NULL;

				if( (LN[x].linknum + LN[x].link[z]->linknum)>10 ){
					ShowMessage("ERROR OVFL_02");
				}
				w=0;
				for(y=LN[x].linknum;y<10;y++){
					LN[x].link[y]=LN[x].link[z]->link[w++];
				}
				LN[x].link[z]->linknum=0;

			}

		}
	}

	a1_1:
*/




//ALAKZATKERESES

//TEGLATEST KERESESE
	lines* Oldal1[1000];	//negativ meredekseg  ( / )
	lines* Oldal2[1000];	//pozitiv meredekseg  ( \ )
	lines* Oldal3[1000];	//fuggoleges egyenes  ( | )
	int po1=0;
	int po2=0;
	int po3=0;
	for(x=0;x<1000;x++){
		Oldal1[x]=NULL;
		Oldal2[x]=NULL;
		Oldal3[x]=NULL;
	}
	//vonalak kivalogatasa
	for(x=0;x<pDB;x++){
		if( (*PlineDB[x]).num>10 ){
			if( ((*PlineDB[x]).m<0.0) && ( (*PlineDB[x]).m>=-2.0 ) ){
				Oldal1[po1++]=PlineDB[x];
			}
			if( ((*PlineDB[x]).m>0.0) && ( (*PlineDB[x]).m<=2.0 ) ){
				Oldal2[po2++]=PlineDB[x];
			}
			if( fabs((*PlineDB[x]).m)>2.0 ){
				Oldal3[po3++]=PlineDB[x];
			}
		}
	}

	//TRINARY CONNECT-LINE ALGORITHM
	//Meghosszabbitasos vonal osszekapcsolo
	lines** O;
	int o,po;
	float M1,M2,B1,B2;
	long len;
	long tav,tav1,tav2,tav3,tav4;
	int tmode;
	for(o=0;o<3;o++){
		switch(o){
			case 0:
				O=Oldal1;
				po=po1;
				break;
			case 1:
				O=Oldal2;
				po=po2;
				break;
			case 2:
				O=Oldal3;
				po=po3;
				break;
		}
		for(x=0;x<po;x++){
			for(y=0;y<po;y++){
				M1=O[x]->m;
				M2=O[y]->m;
				if(
					fabs(( M1 - M2 )/  ( ((M1==0.0)&&(M2==0.0)) ? 0.1 : ((M1!=0.0)?M1:M2) ) )<0.2	//threshold
				){
					if(x==y)continue;
					B1=O[x]->b;
					B2=O[y]->b;
					if(
						fabs(( B1 - B2 )/  ( ((B1==0.0)&&(B2==0.0)) ? 0.1 : ((B1!=0.0)?B1:B2) ) )<0.2   	//threshold
					){
						len=(( O[x]->num>O[y]->num )?O[x]->num:O[y]->num)/2;
						tav1=(O[x]->start->X-O[y]->start->X)*(O[x]->start->X-O[y]->start->X)+(O[x]->start->Y-O[y]->start->Y)*(O[x]->start->Y-O[y]->start->Y);
						tav2=(O[x]->start->X-O[y]->end->X)*(O[x]->start->X-O[y]->end->X)+(O[x]->start->Y-O[y]->end->Y)*(O[x]->start->Y-O[y]->end->Y);
						tav3=(O[x]->end->X-O[y]->start->X)*(O[x]->end->X-O[y]->start->X)+(O[x]->end->Y-O[y]->start->Y)*(O[x]->end->Y-O[y]->start->Y);
						tav4=(O[x]->end->X-O[y]->end->X)*(O[x]->end->X-O[y]->end->X)+(O[x]->end->Y-O[y]->end->Y)*(O[x]->end->Y-O[y]->end->Y);
						tav1=sqrt(tav1);
						tav2=sqrt(tav2);
						tav3=sqrt(tav3);
						tav4=sqrt(tav4);

						if((tav1<tav2)&&(tav1<tav3)&&(tav1<tav4)){tav=tav1;tmode=1;}
						if((tav2<tav1)&&(tav2<tav3)&&(tav2<tav4)){tav=tav2;tmode=2;}
						if((tav3<tav2)&&(tav3<tav1)&&(tav3<tav4)){tav=tav3;tmode=3;}
						if((tav4<tav2)&&(tav4<tav3)&&(tav4<tav1)){tav=tav4;tmode=4;}

						if(tav<len){
							//concatenate 2 lines
							//1.link together
							//2.delete line from ordinary list
							//3.delete line from neighbourhood graph
							int NUM;
							int w;
							for(w=0;w<O[y]->num;w++ ){
								NUM=O[x]->num;
								O[x]->lpoints[NUM]=O[y]->lpoints[w];
								NUM++;
								if(NUM>=OSZ){
									ShowMessage("ERROR OVFL_01");
									continue;
								}
								O[x]->num=NUM;
							}
							O[y]->num=0;
							//delete from Ordinary list, Ordinary list will be unordered
							PlineDB[ O[y]->ord ]=NULL;
							//delete from neighbourhood graph
							LN[ O[y]->ord ].owner=NULL;
							//nasolas
							if( (LN[ O[x]->ord ].linknum + LN[ O[y]->ord ].linknum)>10 )  // union of the 2 point, after : ellenorizni h van-e oda - vissza mutato pointer
								ShowMessage("ERROR OVFL_02");
							}
							w=0;
							for(z=0;z<LN[ O[y]->ord ].linknum;z++ )
								LN[ O[x]->ord ].link[ LN[ O[x]->ord ].linknum++ ]=LN[ O[y]->ord ].link[z];
							//sajatmaga benne van-e
							for(z=0;z<LN[ O[x]->ord ].linknum;z++ )
								if(LN[ O[x]->ord ].link[z]==&LN[ O[x]->ord ] ){
									for(w=z;w<9;w++)
										LN[ O[x]->ord ].link[w]=LN[ O[x]->ord ].link[w+1];
									LN[ O[x]->ord ].link[9]=NULL;
								}
							//delete itself from neughbours
							int k;
							for(z=0;z<LN[ O[y]->ord ].linknum;z++ )
								for(w=0;w<LN[ O[y]->ord ].link[z]->linknum;w++ )
									if(LN[ O[y]->ord ].link[z]->link[w]==&LN[ O[y]->ord ])
										for(k=w;k<10;k++ ){
											if(k==9)LN[ O[y]->ord ].link[z]->link[w]=NULL;
											else
                                            	LN[ O[y]->ord ].link[z]->link[k]=LN[ O[y]->ord ].link[z]->link[k+1];
										}

							//start - end
							switch(tmode){
								case 1:
									O[x]->start=O[x]->end;
									O[x]->end=O[y]->end;
									break;
								case 2:
									O[x]->start=O[x]->end;
									O[x]->end=O[y]->start;
									break;
								case 3:
									O[x]->start=O[x]->start;
									O[x]->end=O[y]->end;
									break;
								case 4:
									O[x]->start=O[x]->start;
									O[x]->end=O[y]->start;
									break;
							}
						
						}
					}
				}
			}
		}
	}

	//Re-order Ordinary list


	//DRAW
	for(z=0; z<O[x]->num; z++ ){
		Image1->Picture->Bitmap->Canvas->Pixels[ O[x]->lpoints[z]->X ][ O[x]->lpoints[z]->Y ]=0x0000FF;
	}
	for(z=0; z<O[y]->num; z++ ){
		Image1->Picture->Bitmap->Canvas->Pixels[ O[y]->lpoints[z]->X ][ O[y]->lpoints[z]->Y ]=0x00FF00;
	}

	


	//delete
	delete[] LN;
	delete [] tl.lpoints;
	for(x=0;x<500;x++){
		delete [] line->lpoints;
	}
}


//Compute cross point of lines
int __fastcall TForm8::CrossPoint(lines* l1, lines* l2){
	float m1 = l1->m;
	float b1 = l1->b;
	float m2 = l2->m;
	float b2 = l2->b;

	if( (m1-m2)==0.0 )return 0;

	P.x= (b2-b1)/(m1-m2);
	P.y= (int)(m1*(float)(P.x)+b1);

	if( (P.x<0)||(P.x>OSZ) )return 0;
	if( (P.y<0)||(P.y>SOR) )return 0;

	return 1;
}

//Check if point is near the line
#define maxtavN 50
int __fastcall TForm8::IsNearby( lines* l){
	int tav;
	int dx,dy;
	dx=abs(l->start->X - P.x);
	dy=abs(l->start->Y - P.y);
	if((dx<maxtavN)&&(dy<maxtavN)){
		if(DEBUG){

			Image1->Picture->Bitmap->Canvas->Pen->Color=0x00FFFF;
			Image1->Picture->Bitmap->Canvas->MoveTo( 0,0 );
			Image1->Picture->Bitmap->Canvas->LineTo( P.x,P.y );


		}
		return 1;

	}

	dx=abs(l->end->X - P.x);
	dy=abs(l->end->Y - P.y);
	if((dx<maxtavN)&&(dy<maxtavN)){
		if(DEBUG){
			Image1->Picture->Bitmap->Canvas->Pen->Color=0x00FFFF;
			Image1->Picture->Bitmap->Canvas->MoveTo( 0,0 );
			Image1->Picture->Bitmap->Canvas->LineTo( P.x,P.y );

		}
		return 1;

	}

	return 0;

}

//two lines are paralell
int __fastcall TForm8::IsParalell( lines* M, lines* N){
	if(
		fabs(( M->m - N->m )/  ( ((M->m==0.0)&&(N->m==0.0)) ? 0.1 : ((N->m!=0.0)?N->m:M->m) ) )<0.2 	//threshold
	){
		if( M->num>N->num ){
			if(M->num>(2*N->num))
				return 0;
			else
				return 1;
		}else{
			if(N->num>(2*M->num))
				return 0;
			else
				return 1;
		}
	}
	return 0;
}

