//---------------------------------------------------------------------------

#ifndef HoughH
#define HoughH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ExtDlgs.hpp>
#include <jpeg.hpp>


#include "ZoomWindow.h"
#include "HoughParamIn.h"



//---------------------------------------------------------------------------
class TForm8 : public TForm
{
__published:	// IDE-managed Components
	TButton *Button1;
	TImage *Image1;
	TOpenPictureDialog *OpenPictureDialog1;
	TButton *Button2;
	TButton *Button3;
	TButton *Button4;
	TButton *Button5;
	TButton *Button6;
	TButton *Button7;
	TCheckBox *CheckBox1;
	TButton *Button8;
	TButton *Button9;
	TButton *Button10;
	TBevel *Bevel1;
	TButton *Button11;
	TButton *Button12;
	TButton *Button13;
	TButton *Button14;
	TButton *Button15;
	TButton *Button16;
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall Button3Click(TObject *Sender);
	void __fastcall Button4Click(TObject *Sender);
	void __fastcall mouse(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y);
	void __fastcall Button5Click(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall Button6Click(TObject *Sender);
	void __fastcall Button7Click(TObject *Sender);
	void __fastcall mouseup(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall mousemove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall Button8Click(TObject *Sender);
	void __fastcall Button9Click(TObject *Sender);
	void __fastcall Button10Click(TObject *Sender);
	void __fastcall Button11Click(TObject *Sender);
	void __fastcall Button12Click(TObject *Sender);
	void __fastcall Button13Click(TObject *Sender);
	void __fastcall Button14Click(TObject *Sender);
	void __fastcall Button15Click(TObject *Sender);
	void __fastcall Button16Click(TObject *Sender);
private:	// User declarations

//Functions
	void normalize();
	void Drawout(int kep[OSZ][SOR]);
	void fputint(int x);
	void fputfloat(float x);
	int fgetint();
	float fgetfloat();
	void __fastcall Prefilter();
	int __fastcall PointAmb(int x,int y);
	void __fastcall PointAmbSign(int x,int y);
	void MarkPixel(int x,int y,int color);
	void __fastcall LineFollow();
	void __fastcall FilterTheta();
	void __fastcall HeuristicLineDet();
	int __fastcall CrossPoint(lines* l1, lines* l2);
	int __fastcall IsNearby( lines* l );
	point P;
	int __fastcall IsParalell( lines* M, lines* N);	

//Subgraph functions for eliminate noise from edge graph
	int CountSpike(ldata*ld);
	void DeleteSpike(ldata*ld);
	int RecursionLevel;

//Numbering graph
	void RenumberGraph(ldata* start,int gnum);

//Creating linking pairs for detecting lines. This shows which neighbours are on a line.
	void CreateLinkPairs(ldata* ld);

//Searching Continuous curves
	int enableCur;
	curves* cur;
	int curpoi;
	int ClusterizeSubCurve(ldata* ld, ldata* axon, int clusterNo, char dir);

//Structures for Pictures
	int OriKep[OSZ][SOR];	//Original picture
	int BWkep[OSZ][SOR];	//Black and White pic.

	float thetas[OSZ][SOR];
	int linecolimage[OSZ][SOR];

	int inputkep[OSZ][SOR];
	int reskep[OSZ][SOR];
	int tempkep[OSZ][SOR];

	inclination incl[OSZ][SOR];

//Data Structures for Hough transform
	hough*** H;
	linestat** stat;
	linestat* statord [STATORDMAX];
//Data Structures for Line detection
	ldata*** L;		//line graph
	char LocalAngleCompuEN;		//Enable compute of local angles

	int DEBUG;

public:		// User declarations
	__fastcall TForm8(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm8 *Form8;
//---------------------------------------------------------------------------
#endif
