//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "HoughParamIn.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm11 *Form11;



//---------------------------------------------------------------------------
__fastcall TForm11::TForm11(TComponent* Owner)
	: TForm(Owner)
{
	L=NULL;
	RST_StepForward1();
	R=NULL;
	Th=NULL;
}
//---------------------------------------------------------------------------
__fastcall TForm11::~TForm11()
///: TForm(Owner)
{
	if(L)delete L;
	if(R)delete R;
	if(Th)delete Th;
}
//---------------------------------------------------------------------------
void __fastcall TForm11::Button1Click(TObject *Sender)
{
	if(OpenPictureDialog1->Execute()){
		Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
	}
}

//---------------------------------------------------------------------------
ldata* TForm11::GetLXY(int x,int y){
	if(!L)return NULL;
	int w;
	for(w=0;w<pMAX;w++){
		if((L[w].X==x)&&(L[w].Y==y)){
			return &L[w];
		}
	}
	return NULL;
}

//---------------------------------------------------------------------------
void TForm11::RST_StepForward1(){
	stepAct=NULL;
	stepPrev=NULL;
	for(int x=0;x<pMAX;x++){
		L[x].graphord=0;
	}
}

ldata* TForm11::StepForward1(){
	if((stepAct==NULL)||(stepPrev==NULL)){
		stepAct=&L[0];
		stepPrev=L[0].link[0];
		return stepAct;
	}
	if(stepAct->link[0]!=stepPrev){
		if(stepAct->link[0]->graphord){
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X ][ stepAct->Y ]=0x0000FF;
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X ][ stepAct->Y+1 ]=0x0000FF;
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X ][ stepAct->Y-1 ]=0x0000FF;
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X-1 ][ stepAct->Y ]=0x0000FF;
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X+1 ][ stepAct->Y ]=0x0000FF;
			ShowMessage("ERROR in circle - StepForward1");
			return NULL;
		}
		stepPrev=stepAct;
		stepAct=stepAct->link[0];
	}else{
		if(stepAct->link[1]->graphord){
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X ][ stepAct->Y ]=0x0000FF;
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X ][ stepAct->Y+1 ]=0x0000FF;
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X ][ stepAct->Y-1 ]=0x0000FF;
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X-1 ][ stepAct->Y ]=0x0000FF;
			Image1->Picture->Bitmap->Canvas->Pixels[ stepAct->X+1 ][ stepAct->Y ]=0x0000FF;
			ShowMessage("ERROR in circle - StepForward1");
			return NULL;
		}
		stepPrev=stepAct;
		stepAct=stepAct->link[1];
	}
	stepAct->graphord=1;	
	return stepAct;
}
//---------------------------------------------------------------------------
ldata* TForm11::StepForward(int num){
	for(int x=0;x<num;x++)
		StepForward1();
	return stepAct;		
}

//---------------------------------------------------------------------------
void __fastcall TForm11::Button2Click(TObject *Sender)
{
//Generate parameters

//Linking Graph
	pMAX=0;
	int x,y;
	if(L)ShowMessage("ERROR");
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(Image1->Picture->Bitmap->Canvas->Pixels[x][y]!=0xFFFFFF){
				pMAX++;
			}
		}

	L=new(ldata[pMAX]);
	for(x=0;x<pMAX;x++){
		for(y=0;y<10;y++)L[x].link[y]=NULL;
		L[x].linkpairs=NULL;
		L[x].linknum=0;
		L[x].X=0;
		L[x].Y=0;
		L[x].graphord=0;
		L[x].CurveCluster=0;
	}

	int Lpoi=0;
	int m,n;
	for(y=0;y<SOR;y++)
		for(x=0;x<OSZ;x++){
			if(Image1->Picture->Bitmap->Canvas->Pixels[x][y]!=0xFFFFFF){
				L[Lpoi].X=x;
				L[Lpoi].Y=y;
				Lpoi++;
			}
		}

	ldata* found;
	for(Lpoi=0;Lpoi<pMAX;Lpoi++){
		for(m=-1;m<2;m++){
			for(n=-1;n<2;n++){
				if(!m&&!n)continue;
				if(found=GetLXY(L[Lpoi].X+n,L[Lpoi].Y+m)){
					L[Lpoi].link[ L[Lpoi].linknum++ ]=found;
				}
				if(L[Lpoi].linknum>=2)break;
			}
			if(L[Lpoi].linknum>=2)break;
		}
	}


//Check if circle graph
	int pMAXnew=0;
	RST_StepForward1();
	ldata*s1=StepForward1();
	ldata*s2;

	for(x=0;x<pMAX+10;x++){	//threshold
		s2=StepForward1();
		pMAXnew++;
		if(!s2){
			x=pMAX+10;
		}
		if(s1==s2){
			break;
        }
	}
	if(x>=pMAX+2){
		ShowMessage("ERROR not a circle graph");
		return;
	}
	pMAX=pMAXnew;


//Find reference Origin
	RST_StepForward1();
	s1=StepForward1();
	ldata*s4=StepForward(pMAX/4);
	s2=StepForward(pMAX/4);
	ldata*s3=StepForward(pMAX/4);
	float m1,m2,b1,b2;
	m1=((float)s1->Y-(float)s2->Y)/((float)s1->X-(float)s2->X);
	m2=((float)s3->Y-(float)s4->Y)/((float)s3->X-(float)s4->X);
	b1=(float)s1->Y-m1*(float)s1->X;
	b2=(float)s3->Y-m2*(float)s3->X;
	Ox=(b2-b1)/(m1-m2);
	Oy=m1*Ox+b1;
	Image1->Picture->Bitmap->Canvas->Pixels[Ox][Oy]=0x0000FF;
	Image1->Picture->Bitmap->Canvas->Pixels[Ox-1][Oy]=0x0000FF;
	Image1->Picture->Bitmap->Canvas->Pixels[Ox+1][Oy]=0x0000FF;
	Image1->Picture->Bitmap->Canvas->Pixels[Ox][Oy-1]=0x0000FF;
	Image1->Picture->Bitmap->Canvas->Pixels[Ox][Oy+1]=0x0000FF;

//Get R-Theta array
	RST_StepForward1();
//	s1=StepForward1();
	s2=StepForward1();
	R=new(float[pMAX]);
	Th=new(float[pMAX]);
	for(x=0;x<pMAX;x++){
		R[x]=sqrt( (float)pow2(s2->X-Ox)  +  (float)pow2(s2->Y-Oy) );
		Th[x]=AtanQuotient0360(s2->X-Ox,s2->Y-Oy);
		s2=StepForward1();
	}

//Sort table by Theta
	int csere=1;
	float temp;
	while(csere){
		csere=0;
		for(x=0;x<pMAX-1;x++)
			if(Th[x]>Th[x+1]){
				temp=Th[x];
				Th[x]=Th[x+1];
				Th[x+1]=temp;
				temp=R[x];
				R[x]=R[x+1];
				R[x+1]=temp;
				csere=1;
			}
	}
	 
//Print out to file
	FILE*f;
	f=fopen("D:\\temp\\BlobRef.txt","w");
	if(f==NULL){
		ShowMessage("ERROR file open error");
		return;
	}

	fprintf(f,"R      Theta(rad)\n");
	for(x=0;x<pMAX;x++){
		fprintf(f,"%.2f, %.2f\n",R[x],Th[x]);
	}

	fclose(f);
}
//---------------------------------------------------------------------------
void __fastcall TForm11::Button3Click(TObject *Sender)
{
	Image1->Picture->LoadFromFile("D:\\temp\\_proba2.bmp");
    Button2Click(NULL);
}
//---------------------------------------------------------------------------



