//Header file for Hough transform and line detection

#include <math.h>

#define SOR 384
#define OSZ 512

#define PI 3.14159265
#define STATORDMAX 12*200

int round(float a){
	return (a-floor(a) <0.5)?floor(a):ceil(a);
}

int pow2(int x){
	return x*x;
}

//Rad To Deg
float degr(float x){
	return x/PI*180;
}

//atan(x/y)
float AtanQuotient(float x,float y){
	if(y==0){
		if(x>0)return PI/2;
		else if(x<0) return -PI/2;
		else return 0.0;
	}else {
		return atan(x/y);
	}
}

//atan(y/x) : 0-2PI
float AtanQuotient0360(float x,float y){
	if((x==0.0)&&(y==0.0))
		return 0.0;
	if((x==0.0)&&(y>0.0))
		return PI/2.0;
	if((x==0.0)&&(y<0.0))
		return 3.0*PI/2.0;
	if((y==0.0)&&(x>0.0))
		return 0.0;
	if((y==0.0)&&(x<0.0))
		return PI;

	if((x>0.0)&&(y>0.0))
		return atan(y/x);
	if((x<0.0)&&(y>0.0))
		return atan(y/x)+PI;
	if((x<0.0)&&(y<0.0))
		return atan(y/x)+PI;
	if((x>0.0)&&(y<0.0))
		return 2.0*PI+atan(y/x);
}

struct linestat;

//STRUCTURES FOR HOUGH TRANSFORM
struct hough{//every point has a hough structure
	float theta;
	float radius;
	int lineclass;
	linestat* lineclasspoi;	
	int X;
	int Y;
};

struct linestat{//for line classification
	float theta;
	float radius;
	int num;
	float fuzzynum;
	int xcoord;
	int ycoord;
	int lineclass;
	hough* points[2*OSZ];
};

//STRUCTURES FOR LINE DETECTION
struct linfo{//every point has a linfo structure    - DETECTION1
	linfo* link[10];	//links to neighbour points
	char linknum;		//number of links
	char endpoint;		//endpoint of a line (if ==1)
	float curvature;	//curvature description number
	int curveclassno;
	int xindex;
	int yindex;
};

//struct for found lines
struct linedata{//structure for line classification - DETECTION1
	linfo* start;		//start point
	linfo* end;			//end point
	int pnum;			//number of points
	char circle;		//1 if circle graph
};

struct ldata{//structure for line classification - DETECTION2
	ldata* link[10];	//links to neighbour points
	ldata*** linkpairs;	//CROSSTABLE: links for corner points (links of links)  sarokpontok hol folytatodnak egy egyenesen 
	char linknum;		//number of links
	int X;
	int Y;
	int graphord;		//graph sorszam
	int CurveCluster;	//Cluster No of curve
	float LocalAngle;	//angle of the local line (line detection)
};

struct lines{//structure for line classification - DETECTION2
	int ord;
	ldata** lpoints;	//points of the line
	int num;			//number of points of the line
	float m;
	float b;
	ldata* start;
	ldata* end;
};

struct graphdata{//Graph data				     - DETECTION2
	int graphnumber;
	ldata* startpoint;
	int num;
};

struct curves{//Structure for found curves		 - DETECTION2
	int curvenum;
	ldata* startpoint;
	ldata* endpoint;
	int num;
	ldata** points;	
};

struct inclination{
	int dx;
	int dy;
};

struct point{
	int x;
	int y;
};

