//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "KohonenMap.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm9 *Form9;
//---------------------------------------------------------------------------
__fastcall TForm9::TForm9(TComponent* Owner)
	: TForm(Owner)
{
}

float TForm9::sigmoid(float x){
	if(x<-200)return 0;
	if(x>200)return 1;
	return (1/(1+exp(-x)));
}

float TForm9::sig(float x){
	return sigmoid(x)-0.5;
}

float TForm9::randweight(){
	float num;
	num=(floor(Random(100)-50))/1000;
	return num;
}

void TForm9::propogate(){
	int x,y,z;
	float sum;
	for(x=0;x<10;x++)
		for(y=0;y<10;y++){
			sum=0;
			for(z=0;z<3;z++)
				sum+=neu[x][y].w[z];
			neu[x][y].out=sigmoid(sum);
		}
}

void TForm9::split(int x){
	in[0]=(x&0xFF0000)>>16;
	in[1]=(x&0x00FF00)>>8;
	in[2]=(x&0x0000FF);
}

neus* TForm9::winner(int sample){
	int x,y;
	split( samle[sample] );

	float minvectav;
	float vectav;
	minvectav=sqrt(
		(neu[0][0].w[0]-in[0])*(neu[0][0].w[0]-in[0])+
		(neu[0][0].w[1]-in[1])*(neu[0][0].w[1]-in[1])+
		(neu[0][0].w[2]-in[2])*(neu[0][0].w[2]-in[2])
	);
	neus* sel=&neu[0][0];

	for(x=0;x<10;x++)
		for(y=0;y<10;y++){
			vectav=sqrt(
				(neu[x][y].w[0]-in[0])*(neu[x][y].w[0]-in[0])+
				(neu[x][y].w[1]-in[1])*(neu[x][y].w[1]-in[1])+
				(neu[x][y].w[2]-in[2])*(neu[x][y].w[2]-in[2])
			);
			if(vectav<minvectav){
				minvectav=vectav;
				sel=&neu[x][y];
			}
		}
	return sel;
}

void TForm9::learn(int wx,int wy,int sample){
	int x,y,z;
	float mue=0.1;
	split( samle[sample] );
	for(x=0;x<10;x++)
		for(y=0;y<10;y++){
			for(z=0;z<3;z++){
				neu[x][y].w[z]=neu[x][y].w[z]+mue*gauss[10-(wx-x)][10-(wy-y)]*( in[z]-neu[x][y].w[z] );
			}
		}
}

//---------------------------------------------------------------------------
void __fastcall TForm9::create(TObject *Sender)
{
	int x,y,z;
	for(x=0;x<10;x++)
		for(y=0;y<10;y++)
			pix[x][y]=0xFFFFFF;

	for(x=0;x<10;x++)
		for(y=0;y<10;y++){
			neu[x][y].x=x;
        	neu[x][y].y=y;			
			for(z=0;z<3;z++)
				neu[x][y].w[z]=randweight();
		}

	for(x=0;x<20;x++)
		for(y=0;y<20;y++){
			gauss[x][y]=exp(-6.667*((x-10)*(x-10)+(y-10)*(y-10)));
		}

	samle[0]=0xFF0022;
	samle[1]=0xEEAA55;
	samle[2]=0xAABBEE;
	samle[3]=0xDD32EE;
	samle[4]=0xFFED11;
	samle[5]=0x00FF00;
	samle[6]=0x0000FF;
	samle[7]=0xFF0000;
	samle[8]=0xDDEF77;
	samle[9]=0x998811;
	samle[10]=0xAAD323;
	samle[11]=0xEDA267;
	samle[12]=0x129F44;
	samle[13]=0xEF9898;
	samle[14]=0x99AA99;
	samle[15]=0x0000BB;
	samle[16]=0xFFEEAA;
	samle[17]=0xea34f5;
	samle[18]=0x999989;
	samle[19]=0xBBFFCC;

	Onpaint(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm9::Onpaint(TObject *Sender)
{
	int x,y;
	TRect r;

	for(x=0;x<10;x++)
		for(y=0;y<10;y++){
			Canvas->Brush->Color=pix[x][y];
			Canvas->Pen->Color=0x000000;
			r.Left=10+x*30;
			r.top=10+y*30;
			r.right=r.Left+30;
			r.Bottom=r.top+30;
			Canvas->Rectangle(r);
		}

	for(x=0;x<20;x++){
		r.Left=360;
		r.top=x*10+20;
		r.right=r.Left+10;
		r.Bottom=r.top+10;
		Canvas->Brush->Color=samle[x];
		Canvas->FillRect(r);
	}

}
//---------------------------------------------------------------------------

void __fastcall TForm9::Button1Click(TObject *Sender)
{
	//START
	int x,y,w;
	for(w=0;w<20;w++){
		split(samle[w]);
		propogate();

	}



	pix[1][2]=0x22FF22;
	pix[5][5]=0x2233FF;
	Onpaint(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TForm9::Button2Click(TObject *Sender)
{
	static int tnum=0;
	int x,y;
	split(samle[tnum]);
	propogate();

	neus*win=winner(tnum);

	learn(win->x, win->y ,tnum);

	for(x=0;x<10;x++)
		for(y=0;y<10;y++){
			pix[x][y]=0xFFFFFF;
		}
	pix[ win->x ][ win->y ]=samle[tnum];



	tnum++;
	if(tnum>19)tnum=0;
	Onpaint(NULL);
}
//---------------------------------------------------------------------------

