//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "Neural.h"
#include "Askweight.cpp"
#include "EditNeu.cpp"
#include "LearnStat.cpp"
#include "Backprop.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//1-normal neuron
//2-stimulated neuron
//3-sensor
TForm1 *Form1;
HDC memDC[MAXGATE];		//Bitmaps for NEU
HBITMAP memBM[MAXGATE];


//Load the Bitmaps of the logic gates
void TForm1::LoadNeu(){
	AnsiString name[3];
	int pos,x,y;
	int fileHandler;
	BYTE*memp;
	int p=0;
	int r,g,b;
	name[0]="neu.pic";
	name[1]="neufire.pic";
	name[2]="sensor.pic";

	HDC hdc=Canvas->Handle;
	for(pos=0;pos<3;pos++){
		memDC[pos] = CreateCompatibleDC ( hdc );
		memBM[pos] = CreateCompatibleBitmap ( hdc,10,10 );
		SelectObject ( memDC[pos], memBM[pos] );

		fileHandler = FileOpen(name[pos], GENERIC_READ);
		if(fileHandler==-1) ShowMessage(name[pos] + " - File Open ERROR");
		else {
			memp=new BYTE [1000];
			FileRead(fileHandler, memp, 1000);
			FileClose(fileHandler);

			p=0;
			for(y=0;y<10;y++){
				while(memp[p]!=':')p++;
				p++;
				for(x=0;x<10;x++){
					r=0;g=0;b=0;
					switch(memp[p++]){
						case 'R': r=0xFF;
							break;
						case 'G': g=0xFF;
							break;
						case 'B': b=0xFF;
							break;
						case 'Y': r=0xFF; g=0xFF;
							break;
						case 'C': b=0xFF; g=0xFF;
							break;
						case 'M': b=0xFF; r=0xFF;
							break;
						case '0': r=0xFF; g=0xFF; b=0xFF;
							break;
						default:  r=0xFF; g=0xFF; b=0xFF;
							break;
					}
					SetPixel(memDC[pos],x,y,RGB(r,g,b));
				}
			}
			delete memp;
		}
	}
}

//Dispay the Bitmaps of the logic gates
//if corner==1 ->plot to the current color display
//gate : from 1->3
void TForm1::PlotGates(int x,int y,int gate,int corner){
	HDC hdc=Canvas->Handle;
	x*=10;y*=10;
	if(!corner)
		BitBlt(hdc,x,y,10,10,memDC[gate-1],0,0,SRCCOPY);
	else{
		x=515;y=480;
		BitBlt(hdc,x,y,10,10,memDC[gate-1],0,0,SRCCOPY);
    }
}

//redraw the window
void TForm1::DrawOut(){
	int x,y,m,n,mi,ni;
	int pos;
	int disx,disy;
	RECT r;
	r.left=0;
	r.top=0;
	r.right=500;
	r.bottom=500;
	Canvas->Brush->Color=0xFFFFFF;
	Canvas->FillRect(r);
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
		if(X[x][y]>0)PlotGates(x,y,X[x][y],0);
	}
	PlotGates(0,0,actgate,1);
	if((radio==2)&&(selected!=NULL)){
		pos=0;
		while((selected->link[pos]!=NULL)&&(pos<20)){
			Canvas->Pen->Color=0x000000;
			Canvas->MoveTo(selected->posx*10+5,selected->posy*10+5);
			x=selected->link[pos]->posx;y=selected->link[pos]->posy;
			Canvas->LineTo(x*10+5,y*10+5);

			Canvas->Pen->Color=0x0000FF;
			Canvas->Pen->Width=2;
			Canvas->MoveTo(selected->posx*10+5,selected->posy*10+5);
			disx=x*10+5-(selected->posx*10+5);
			disy=y*10+5-(selected->posy*10+5);
			disx/=4; disy/=4; disx+=selected->posx*10+5; disy+=selected->posy*10+5;
			Canvas->LineTo(disx,disy);
			Canvas->Pen->Color=0x000000;
			Canvas->Pen->Width=1;
			pos++;
		}
	}
	if(shownet){
		for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
			if(list[x][y]!=NULL){
				pos=0;
				while((list[x][y]->link[pos]!=NULL)&&(pos<20)){
					Canvas->Pen->Color=0xFF00FF;
					Canvas->MoveTo(list[x][y]->posx*10+5,list[x][y]->posy*10+5);
					m=list[x][y]->link[pos]->posx;
					n=list[x][y]->link[pos]->posy;
					Canvas->LineTo(m*10+5,n*10+5);

					mi=list[x][y]->posx*10+5;
					ni=list[x][y]->posy*10+5;
					Canvas->Pen->Color=0x0000FF;
					Canvas->Pen->Width=2;
					Canvas->MoveTo(mi,ni);
					disx=m*10+5-(mi);
					disy=n*10+5-(ni);
					disx/=4; disy/=4; disx+=mi; disy+=ni;
					Canvas->LineTo(disx,disy);
					Canvas->Pen->Width=1;
					pos++;
				}
			}
		}
	}
	if(((radio==3)||(CheckBox3->Checked))&&(selected!=NULL)){
		Canvas->Pen->Color=0x000000;
		Canvas->Brush->Color=0x000000;
		disx=selected->posx*10+5;
		disy=selected->posy*10+5;
		RECT r;
		r.left=disx-5;
		r.top=disy-5;
		r.right=disx+5;
		r.bottom=disy+5;
		Canvas->FrameRect (r);
		if(showallweights){
			Canvas->Pen->Color=0x00FF00;
			pos=0;
			while((pos<20)&&(selected->link[pos]!=NULL)){
				Canvas->MoveTo(selected->posx*10+5,selected->posy*10+5);
				m=selected->link[pos]->posx;
				n=selected->link[pos]->posy;
				Canvas->LineTo(m*10+5,n*10+5);
				pos++;
			}
		}
	}
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	int x,y;
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
		X[x][y]=0;list[x][y]=NULL;
	}
	actgate=1; radio=1; inconnect=0;
	selected=NULL; w_edit=0;    run=0;
	shownet=0;
	learn=0;
	RandSeed=11;
	LoadNeu();
	DrawOut();
	Form5->SetSelected(&selected);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Paint(TObject *Sender)
{
	DrawOut();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::keydwn(TObject *Sender, char &Key)
{
	int x,y;
	//C: change color
	if(Key=='c'){
		actgate++;
		if(actgate>3)actgate=1;
		PlotGates(0,0,actgate,1);
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::mouse(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int x, int y)
{
	int pos,poss;
	int disx,disy;
	if(x>500)return;
	if(y>500)return;
	x=x/10;y=y/10;
	if(Button==mbLeft){
		if(CheckBox3->Checked){
			//Backpropogation mode
			if(X[x][y]){
				selected=list[x][y];
				DrawOut();
			}
			if(radio!=3)return;
		}
		if(radio==1){//Place neurons
			if(X[x][y]){
				X[x][y]=0;
				for(disx=0;disx<SIZE;disx++)for(disy=0;disy<SIZE;disy++){
					pos=0;
					if(list[disx][disy])
					while((pos<20)&&(list[disx][disy]->link[pos]!=NULL)){
						if(list[disx][disy]->link[pos]==list[x][y]){
							list[disx][disy]->link[pos]=NULL;
							list[disx][disy]->weight[pos]=0;
							for(poss=pos;poss<19;poss++){
								list[disx][disy]->link[poss]=list[disx][disy]->link[poss+1];
								list[disx][disy]->weight[poss]=list[disx][disy]->weight[poss+1];
							}
							list[disx][disy]->link[19]=NULL;
							list[disx][disy]->weight[19]=0;
						}
						pos++;
					}
				}
				if(list[x][y]!=NULL){
					delete list[x][y]; list[x][y]=NULL;
				}
			}
			else {
				X[x][y]=actgate;list[x][y]=new(neuron);
				list[x][y]->posx=x;list[x][y]->posy=y;
				list[x][y]->threshold=0;
				for(pos=0;pos<20;pos++){
					list[x][y]->link[pos]=NULL;list[x][y]->weight[pos]=0;
				}
			}
			DrawOut();
		}
		if(radio==2){//Connect neurons together
			if((inconnect==0)&&(X[x][y])){
				inconnect=1;
				selected=list[x][y];
			} else if(X[x][y]) {
				inconnect=0;
				DrawOut();
				pos=0;
				while((pos<20)&&(selected->link[pos]!=NULL)){
					if(selected->link[pos]==list[x][y]){
						ShowMessage("This connection already exists");
						return;
					}
					pos++;
				}
				Canvas->Pen->Color=0x000000;
				Canvas->MoveTo(selected->posx*10+5,selected->posy*10+5);
				Canvas->LineTo(x*10+5,y*10+5);

				Canvas->Pen->Color=0x0000FF;
				Canvas->Pen->Width=2;
				Canvas->MoveTo(selected->posx*10+5,selected->posy*10+5);
				disx=x*10+5-(selected->posx*10+5);
				disy=y*10+5-(selected->posy*10+5);
				disx/=4; disy/=4; disx+=selected->posx*10+5; disy+=selected->posy*10+5;
				Canvas->LineTo(disx,disy);
				Canvas->Pen->Color=0x000000;
				Canvas->Pen->Width=1;

				if(pos>19){ShowMessage("ERROR max links over than 20");return;}
				selected->link[pos]=list[x][y];

				Form2->Edit1->Text="0.1";
				if(Form2->ShowModal() == mrOk)
				{
					   //Akkor fut le ha ok-t nyomtak
				}
				selected->weight[pos]=weight;
			}
		}
		if((radio==3)&&(X[x][y])){
			selected=list[x][y];
			Form3->LoadWeights(list[x][y]);
			Form3->Show();
			DrawOut();
		}
		if((radio==4)&&(X[x][y])){
			selected=list[x][y];
			if(X[x][y]==1){   //stimulate
				selected->axon=FIRING;
				X[x][y]=2;
			}else if(X[x][y]==2){   //destimulate
				selected->axon=REST;
				X[x][y]=1;
			}
			DrawOut();
		}
	}
	if(Button==mbRight){
		actgate=X[x][y];
		PlotGates(0,0,actgate,1);
		if(radio==2){
			inconnect=0;
			DrawOut();
		}
	}	
}
//---------------------------------------------------------------------------


//OPEN configuration
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	int x,y,pos;
	int xreg,yreg,linkno;
	neuron *sel;
	AnsiString s;
	TStringList *config=new(TStringList);
	int thresholds=0;

	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){list[x][y]=NULL;X[x][y]=0;}
	OpenDialog1->Filter="ANN configuration (*.ann)|*.ANN";
	if(OpenDialog1->Execute()){
		config->LoadFromFile(OpenDialog1->FileName);
		pos=0;
		do{
			if(!config->Strings[pos].AnsiCompare("THRESHOLDS")){
				thresholds=1;break;
			}
			if(config->Strings[pos++].AnsiCompare("NEURON")){
				ShowMessage("Format error");return;
			}
			if(config->Strings[pos++].AnsiCompare("params")){
				ShowMessage("Format error");return;
			}
			xreg=config->Strings[pos++].ToInt();
			yreg=config->Strings[pos++].ToInt();
			if(!list[xreg][yreg])list[xreg][yreg]=new(neuron);
			sel=list[xreg][yreg];
			sel->threshold=0;
			sel->posx=xreg;
			sel->posy=yreg;
			sel->axon=config->Strings[pos++].ToDouble();
			X[xreg][yreg]=config->Strings[pos++].ToInt();
			if(pos>config->Count-1)break;
			linkno=0;
			while((pos<config->Count)&&(!config->Strings[pos].AnsiCompare("link"))){
				pos++;
				xreg=config->Strings[pos++].ToInt();
				yreg=config->Strings[pos++].ToInt();
				if(!list[xreg][yreg]){list[xreg][yreg]=new(neuron);X[xreg][yreg]=1;}
				sel->link[linkno]=list[xreg][yreg];
				sel->weight[linkno++]=config->Strings[pos++].ToDouble();
			}

		}while(pos<config->Count);
		if(thresholds){
        	pos++;
			for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
				if(list[x][y]){
					list[x][y]->threshold=config->Strings[pos++].ToDouble();
				}
			}
		}
	}
	delete config;
	DrawOut();
}
//---------------------------------------------------------------------------


//SAVE configuration
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	int x,y,pos;
	neuron *sel;
	AnsiString s;
	TStringList *config=new(TStringList);
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
		if(list[x][y]){
			sel=list[x][y];
			s="NEURON";config->Add(s);
			s="params";config->Add(s);
			s.sprintf("%d",sel->posx);config->Add(s);
			s.sprintf("%d",sel->posy);config->Add(s);
			s.sprintf("%f",sel->axon);config->Add(s);
			s.sprintf("%d",X[x][y]);config->Add(s);

			pos=0;
			while((pos<20)&&(sel->link[pos]!=NULL)){
				s="link";config->Add(s);
				s.sprintf("%d",sel->link[pos]->posx);config->Add(s);
				s.sprintf("%d",sel->link[pos]->posy);config->Add(s);
				s.sprintf("%f",sel->weight[pos]);config->Add(s);
				pos++;
			}
		}
	}
	//Thresholds - optional
	s="THRESHOLDS";config->Add(s);
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
		if(list[x][y]){
			sel=list[x][y];
			s.sprintf("%f",sel->threshold);config->Add(s);
		}
	}

	SaveDialog1->Filter="ANN configuration (*.ann)|*.ANN";
	if(SaveDialog1->Execute()){

		config->SaveToFile(ChangeFileExt(SaveDialog1->FileName,".ann"));
	}
	delete config;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
	radio=1;
	DrawOut();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
	radio=2;
	DrawOut();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton3Click(TObject *Sender)
{
	radio=3;
	DrawOut();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton4Click(TObject *Sender)
{
	radio=4;
	DrawOut();		
}
//---------------------------------------------------------------------------


void __fastcall TForm1::mousemove(TObject *Sender, TShiftState Shift, int X,
	  int Y)
{
	if(X>499)return;
	if(Y>499)return;
	if(inconnect){
		DrawOut();
		Canvas->Pen->Color=0x000000;
		Canvas->MoveTo(selected->posx*10+5,selected->posy*10+5);
		Canvas->LineTo(X,Y);
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::destroy(TObject *Sender)
{
	int x,y;
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
		if(list[x][y]!=NULL){
			delete list[x][y];
			//X[x][y]=0;list[x][y]=NULL;
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
	if(CheckBox1->Checked)shownet=1;
	else shownet=0;
	DrawOut();
}
//---------------------------------------------------------------------------

//Timer for Weight edit communication
//EditNeu communication back timer
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	int m,n;
	if(showallweightsDelta){
		showallweightsDelta=0;
    	DrawOut();
	}
	if(w_edit){
		DrawOut();
		w_edit--;

		Canvas->Pen->Color=0xFF0000;
		if(selected->link[w_edit]!=NULL){
			Canvas->MoveTo(selected->posx*10+5,selected->posy*10+5);
			m=selected->link[w_edit]->posx;
			n=selected->link[w_edit]->posy;
			Canvas->LineTo(m*10+5,n*10+5);
		}
		w_edit=0;
	}
	if(Form5->editchange){
		Form5->editchange=0;
        DrawOut();
	}
}
//---------------------------------------------------------------------------

//Neuron constructor
neuron::neuron(){
	int x;
	posx=0;
	posy=0;
	axon=0;
	for(x=0;x<20;x++){
    	weight[x]=0;link[x]=NULL;
	}
	axonlist=NULL;
}

void neuron::AddAxonlist(neuron* n,float* w){
	if(axonlist==NULL){ShowMessage("ERROR no axonlist");return;}
	int x;
	for(x=0;x<20;x++){
		if(axonlist[x].axonElem==NULL)break;
	}
	if(x==20){ShowMessage("ERROR full axonlist");return;}
	axonlist[x].axonElem=n;
	axonlist[x].wref=w;
}

//Neuron firing function
void neuron::out(){
	int pos=0;
	float output=0;
	while((pos<20)&&(link[pos]!=NULL)){
		output+=weight[pos]*link[pos]->axonold;
		pos++;
	}
	if(output>THRESHOLD)axon=FIRING;		//TRESHOLD!
	else axon=REST;
	if(Form1->learn==1)learn();
}

//Neuron learning action
void neuron::learn(){
	int x;
	if(axon>THRESHOLD){learncntP++; learncntN=0;}
	else {learncntN++; learncntP=0;}
	learned=0;
	if(learncntP>10){learned=1;for(x=0;x<20;x++)if(link[x]!=NULL){ weight[x]-=0.05;learncntP=0;}}
	if(learncntN>10){learned=1;for(x=0;x<20;x++)if(link[x]!=NULL){ weight[x]+=0.05;learncntN=0;}}
}

//Start simaulation
void __fastcall TForm1::STARTClick(TObject *Sender)
{
	int pos=0;
	int x,y;
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
		if(list[x][y]!=NULL){
			if(X[x][y]==2)list[x][y]->axon=FIRING;
			else list[x][y]->axon=REST;
		}
	}
	run=1;
}
//---------------------------------------------------------------------------

//Simulation timer
void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
	int x,y;
	if(run){
		if(CheckBox3->Checked){
			for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
				if(list[x][y]!=NULL){
					if((list[x][y]->axon)>THRESHOLD)X[x][y]=2;
					else X[x][y]=1;
				}
			}
			DrawOut();
			return;
		}
		for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
			if(list[x][y]!=NULL){
				list[x][y]->axonold=list[x][y]->axon;
			}
		}
		for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
			if(list[x][y]!=NULL){
				list[x][y]->out();             //TRESHOLD!!
				if((list[x][y]->axon)>THRESHOLD)X[x][y]=2;
				else X[x][y]=1;
			}
		}
		DrawOut();
	}
	//learning statistics
	if(learn){
		Form4->stat[419]=0;
		Form4->numofneu=0;
		for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
			if(list[x][y]!=NULL){
				Form4->stat[419]+=list[x][y]->learned;
				Form4->numofneu++;
			}
		}
		for(x=1;x<420;x++){
			Form4->stat[x-1]=Form4->stat[x];
		}
		Form4->graph();
	}
}
//---------------------------------------------------------------------------

//Stop simulation
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	run=0;
}
//---------------------------------------------------------------------------


//new design
void __fastcall TForm1::Button4Click(TObject *Sender)
{
	int x,y;
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
		if(list[x][y]!=NULL){
			delete list[x][y];
		}
	}
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++){
    	list[x][y]=NULL;X[x][y]=0;
	}
	DrawOut();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
	int x,y;
	//Switch on learning function
	if(CheckBox2->Checked)learn=1;
	else learn=0;
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++)if(list[x][y]!=NULL){
		list[x][y]->learncntP=0;
		list[x][y]->learncntN=0;
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button5Click(TObject *Sender)
{
	//RANDOMIZE
	int x,y,pos;
	for(x=0;x<SIZE;x++)for(y=0;y<SIZE;y++)if(list[x][y]!=NULL){
		for(pos=0;pos<20;pos++){
			if(list[x][y]->link[pos]==NULL)break;
			else list[x][y]->weight[pos]=((float)Random(600)-300)/100;
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
	int x;
	Form4->Show();
	for(x=0;x<420;x++)Form4->stat[x]=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
	if(Form1->Timer2->Interval<110)Form1->Timer2->Interval-=10;
	else Form1->Timer2->Interval-=100;
	if(	Form1->Timer2->Interval<10)	Form1->Timer2->Interval=10;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
	if(Form1->Timer2->Interval<110)Form1->Timer2->Interval+=10;
	else Form1->Timer2->Interval+=100;
}
//---------------------------------------------------------------------------

neuron* TForm1::GetList(int x,int y){
	neuron *np=list[x][y];
	int a=np->posx;
	int b=np->posy;
	return np;
}

//Backpropogation activation
void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
	if(CheckBox3->Checked)	Form5->Show();
	else Form5->Hide();
}
//---------------------------------------------------------------------------

//Quick button
void __fastcall TForm1::Button9Click(TObject *Sender)
{
//Quick button
//
	Form8->Show();
	Form8->Button15Click(NULL);
}
//---------------------------------------------------------------------------

