//---------------------------------------------------------------------------

#ifndef NeuralH
#define NeuralH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>

#define MAXGATE 10
#define SIZE 50       	//max SIZE of the X array
#define FIRING 1.0 		//firing neuron output value
#define REST 0.0 		//neuron at rest output value
#define THRESHOLD 0.5	//neuron firing threshold
//1-normal neuron
//2-stimulated neuron
//3-sensor
class neuron{
public:
	neuron();			//constructor
	int posx;        	//matrix coords for display
	int posy;
	int learncntP;		//learning cycle counter: stimulated time
	int learncntN;		//learning cycle counter: unstimulated time
	int learned;		//1 if just learned
	neuron*link[20];
	float weight[20];
	float axon;			//Output state value
	float axonold;		//old axon value
	void out();   		//Firing function
	void learn();		//learning function
//Backpropogation related
	float threshold;
	float sum;
	float delta;
	struct AxonList{
		neuron* axonElem;
		float*  wref;
	}*axonlist;	//axon list: the connected dendrits to the axon; 20 length list!
	void AddAxonlist(neuron* n,float* w);
};

neuron*list[SIZE][SIZE];	//neuron pointer list

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TButton *Button1;
	TButton *Button2;
	TRadioButton *RadioButton1;
	TRadioButton *RadioButton2;
	TRadioButton *RadioButton3;
	TCheckBox *CheckBox1;
	TTimer *Timer1;
	TButton *START;
	TTimer *Timer2;
	TButton *Button3;
	TRadioButton *RadioButton4;
	TOpenDialog *OpenDialog1;
	TSaveDialog *SaveDialog1;
	TButton *Button4;
	TCheckBox *CheckBox2;
	TButton *Button5;
	TButton *Button6;
	TButton *Button7;
	TButton *Button8;
	TCheckBox *CheckBox3;
	TButton *Button9;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall Paint(TObject *Sender);
	void __fastcall keydwn(TObject *Sender, char &Key);
	void __fastcall mouse(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y);
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall RadioButton1Click(TObject *Sender);
	void __fastcall RadioButton2Click(TObject *Sender);
	void __fastcall RadioButton3Click(TObject *Sender);
	void __fastcall mousemove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall destroy(TObject *Sender);
	void __fastcall CheckBox1Click(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall STARTClick(TObject *Sender);
	void __fastcall Timer2Timer(TObject *Sender);
	void __fastcall Button3Click(TObject *Sender);
	void __fastcall RadioButton4Click(TObject *Sender);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall Button4Click(TObject *Sender);
	void __fastcall CheckBox2Click(TObject *Sender);
	void __fastcall Button5Click(TObject *Sender);
	void __fastcall Button6Click(TObject *Sender);
	void __fastcall Button7Click(TObject *Sender);
	void __fastcall Button8Click(TObject *Sender);
	void __fastcall CheckBox3Click(TObject *Sender);
	void __fastcall Button9Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
	void LoadNeu();
	void DrawOut();
	void PlotGates(int x,int y,int gate,int corner);
	int X[SIZE][SIZE];		   	//Array for display
	int actgate;
	int radio;		//radio buttons
//	int selx,sely;	//Coords of Selected items
	neuron *selected;//selected neuron to edit
	int inconnect;	//In connecting together operation
	int shownet;	//Show Network Connections shadowly
	int run;		//Simulation is running
	int learn;		//Learning flag
	neuron* GetList(int x,int y);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif


