//---------------------------------------------------------------------------

//#define test

#include <vcl.h>
#pragma hdrstop

#include "PictureRecognition.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm7 *Form7;

//picture neural network properties
//#define HE 120		//height
//#define WI 160		//width
#define SOR 120		//height  oszthato legyen 4el!
#define OSZ 160		//width   oszthato legyen 4el!
int KEP=SOR*OSZ;	//Size of the input picture
int QKEP=KEP/4;		//Quarter size of input pic.
int inputkep[SOR*OSZ];
int kep1[SOR*OSZ];
int kep2[SOR*OSZ];
int kep3[SOR*OSZ];
int kep4[SOR*OSZ];
int kep5[SOR*OSZ];
int kep6[SOR*OSZ];
int kep7[SOR*OSZ];
int kep8[SOR*OSZ];
int kep9[SOR*OSZ];
int kep10[SOR*OSZ];
int kepcnt=0;

float error;
float maxerr=0.1;
float etha=0.5;

float sigmoid(float x){
	if(x<-200)return 0;
	if(x>200)return 1;
	return (1/(1+exp(-x)));
}

float sig(float x){
	return sigmoid(x)-0.5;
}

float sig_diff(float x){
	float s;
	s=sigmoid(x);
	return (1-s)*s;
}

float randweight(){
	float num;
	num=(floor(Random(100)-50))/1000;
	return num;
}

void TForm7::RandomizeWeights(){
	int x,y;
	//input
	for(x=0;x<KEP;x++){
		pti[x].threshold=randweight();
		for(y=0;y<QKEP;y++){
			pti[x].W[y]=randweight();
		}
	}
	//hidden
	for(x=0;x<KEP;x++){
		pth[x].threshold=randweight();
		for(y=0;y<QKEP;y++){
			pth[x].W[y]=randweight();
		}
	}
	//output
	for(x=0;x<10;x++){
		pto[x].threshold=randweight();
		for(y=0;y<KEP;y++){
			pto[x].W[y]=randweight();
		}
	}
}

void TForm7::propogate(){
	int x,y;
	//input
	for(x=0;x<KEP;x++){
		pti[x].sum=0;
		for(y=0;y<QKEP;y++){
			pti[x].sum+=pti[x].W[y]*inputkep[y*4+(x&0x3)];
		}
		pti[x].sum+=pti[x].threshold;
		pti[x].axon=sigmoid(pti[x].sum);
	}
	//hidden
	for(x=0;x<KEP;x++){
		pth[x].sum=0;
		for(y=0;y<QKEP;y++){
			pth[x].sum+=pth[x].W[y]*pti[y*4+(x&0x3)].axon;
		}
		pth[x].sum+=pth[x].threshold;
		pth[x].axon=sigmoid(pth[x].sum);
	}
	//output
	for(x=0;x<10;x++){
		pto[x].sum=0;
		for(y=0;y<KEP;y++){
			pto[x].sum+=pto[x].W[y]*pth[y].axon;
		}
		pto[x].sum+=pto[x].threshold;
		pto[x].axon=sigmoid(pto[x].sum);
	}
}

int TForm7::backprop(){
	int x,y;
	//COMPUTE DELTA
	//output layer
	error=0.0;
	for(x=0;x<10;x++){
		pto[x].delta=expectedout[x]-pto[x].axon;
		error+=fabs(pto[x].delta);
	}
	if(error<maxerr)
		return 1;//no need to backpropagate.
	//hidden layer
	for(x=0;x<KEP;x++){
		pth[x].delta=0;
		for(y=0;y<10;y++){
			pth[x].delta+=pto[y].W[x]*pto[y].delta;
		}
		pth[x].delta*=pth[x].axon*(1-pth[x].axon);
	}
	//input layer
	for(x=0;x<KEP;x++){
		pti[x].delta=0;
		for(y=0;y<QKEP;y++){
			pti[x].delta+=pth[y*4+(x&0x3)].W[x/4]*pth[y*4+(x&0x3)].delta;
		}
		pti[x].delta*=pti[x].axon*(1-pti[x].axon);
	}
	//CHANGE WEIGHTS
	double length;
	//input layer
	length=0.0;
	for(x=0;x<KEP;x++){
		length+=pti[x].axon*pti[x].axon;
	}
	if (length<=0.1) length = 0.1;
	for(x=0;x<KEP;x++){
		for(y=0;y<QKEP;y++){
			pti[x].W[y]+=etha*pti[x].delta*inputkep[y*4+(x&0x3)]/length;
		}
		pti[x].threshold+=etha*pti[x].delta/length;
	}
	//hidden layer
	length=0.0;
	for(x=0;x<KEP;x++){
		length+=pth[x].axon*pth[x].axon;
	}
	if (length<=0.1) length = 0.1;
	for(x=0;x<KEP;x++){
		for(y=0;y<QKEP;y++){
			pth[x].W[y]+=etha*pth[x].delta*pti[y*4+(x&0x3)].axon/length;
		}
		pti[x].threshold+=etha*pti[x].delta/length;
	}
	//output layer		
	length=0.0;
	for(x=0;x<10;x++){
		length+=pto[x].axon*pto[x].axon;
	}
	if (length<=0.1) length = 0.1;
	for(x=0;x<10;x++){
		for(y=0;y<KEP;y++){
			pto[x].W[y]+=etha*pto[x].delta*pth[y].axon/length;
		}
		pto[x].threshold+=etha*pto[x].delta/length;
	}

	return 0;
}


//---------------------------------------------------------------------------
__fastcall TForm7::TForm7(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
//LOAD
void __fastcall TForm7::Button1Click(TObject *Sender)
{
	if(OpenPictureDialog1->Execute()){
		Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
	}

	int x,y,index=0;
	int c;
	for(x=0;x<SOR;x++)
		for(y=0;y<OSZ;y++){
			c=Image1->Picture->Bitmap->Canvas->Pixels[y][x];
			inputkep[index++]=(c&0xFF)/3+(c&0xFF00)/256/3+(c&0xFF0000)/256/256/3;
		}
	index=0;
	for(x=0;x<SOR;x++)
		for(y=0;y<OSZ;y++){
			Image1->Picture->Bitmap->Canvas->Pixels[y][x]=inputkep[index]+inputkep[index]*256+inputkep[index]*256*256;
			index++;
		}

	switch(kepcnt){
		case 0:
			for(x=0;x<SOR*OSZ;x++)
				kep1[x]=inputkep[x];
			break;
		case 1:
			for(x=0;x<SOR*OSZ;x++)
				kep2[x]=inputkep[x];
			break;
		case 2:
			for(x=0;x<SOR*OSZ;x++)
				kep3[x]=inputkep[x];
			break;
		case 3:
			for(x=0;x<SOR*OSZ;x++)
				kep4[x]=inputkep[x];
			break;
		case 4:
			for(x=0;x<SOR*OSZ;x++)
				kep5[x]=inputkep[x];
			break;
		case 5:
			for(x=0;x<SOR*OSZ;x++)
				kep6[x]=inputkep[x];
			break;
		case 6:
			for(x=0;x<SOR*OSZ;x++)
				kep7[x]=inputkep[x];
			break;
		case 7:
			for(x=0;x<SOR*OSZ;x++)
				kep8[x]=inputkep[x];
			break;
		case 8:
			for(x=0;x<SOR*OSZ;x++)
				kep9[x]=inputkep[x];
			break;
		case 9:
			for(x=0;x<SOR*OSZ;x++)
				kep10[x]=inputkep[x];
			break;
		default:
			ShowMessage("Too much picture loaded");
			break;
	}
	kepcnt++;
}
//---------------------------------------------------------------------------
//Create neurons
void TForm7::init(){
#ifdef test
return;
#endif
	if(initialized)return;
	initialized=1;
	int x,y;
	//create neurons and initialize
	//input
	pti=new(picneu[KEP]);
	for(x=0;x<KEP;x++){
		pti[x].threshold=randweight();
		pti[x].W=new(float[QKEP]);
		for(y=0;y<QKEP;y++){
			pti[x].W[y]=randweight();
		}
	}
	//hidden
	pth=new(picneu[KEP]);
	for(x=0;x<KEP;x++){
		pth[x].threshold=randweight();
		pth[x].W=new(float[QKEP]);
		for(y=0;y<QKEP;y++){
			pth[x].W[y]=randweight();
		}
	}
	//output
	pto=new(picneu[10]);
	for(x=0;x<10;x++){
		pto[x].threshold=randweight();
		pto[x].W=new(float[KEP]);
		for(y=0;y<KEP;y++){
			pto[x].W[y]=randweight();
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm7::FormDestroy(TObject *Sender)
{
#ifdef test
return;
#endif
	if(!initialized)return;
	//delete neurons
	int x,y;
	//input
	for(x=0;x<KEP;x++){
		delete[] pti[x].W;
	}
	delete[] pti;
	//hidden
	for(x=0;x<KEP;x++){
		delete[] pth[x].W;
	}
	delete[] pth;
	//output
	for(x=0;x<10;x++){
		delete[] pto[x].W;
	}
	delete[] pto;
}
//---------------------------------------------------------------------------
void __fastcall TForm7::FormCreate(TObject *Sender)
{
	initialized=0;	
}
//---------------------------------------------------------------------------

//propogate
void __fastcall TForm7::Button3Click(TObject *Sender)
{
	int x;
	
	#ifndef test
	propogate();
	#endif

	//draw out results
	Canvas->Pen->Color=0x0000FF;
	Canvas->MoveTo(330,330);
	Canvas->LineTo(330,370);
	Canvas->LineTo(400,370);
	Canvas->LineTo(400,330);
	Canvas->LineTo(330,330);

	Canvas->Pen->Color=0x00FF00;
	for(x=0;x<10;x++){
		Canvas->MoveTo(331,340+x*2);
		Canvas->LineTo(399,340+x*2);
	}

	Canvas->Pen->Color=0xFF0000;	
	for(x=0;x<10;x++){
		Canvas->MoveTo(331,340+x*2);
		Canvas->LineTo(330+pto[x].axon*68,340+x*2);
	}
	ShowMessage("Propogated");
}
//---------------------------------------------------------------------------

//Learning
void __fastcall TForm7::Button2Click(TObject *Sender)
{
	int i;
	RandomizeWeights();
	for(i=0;i<10;i++){
		expectedout[i]=0;
	}
	expectedout[0]=1;
	for(i=0;i<SOR*OSZ;i++){
		inputkep[i]=kep1[i];
	}
	//Learning
	int prcnt=0;
	AnsiString s;
	int okall=0;
	int w;
	int NUMOFPICTURESTOLEARN=3;
	float ErrorSum=0;
	while(!okall){
		okall=1;
		ErrorSum=0;
		for(i=0;i<NUMOFPICTURESTOLEARN;i++){
			for(w=0;w<10;w++)expectedout[w]=0;
			expectedout[i]=1.0;
			switch(i){
				case 0:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep1[w];
					break;
				case 1:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep2[w];
					break;
				case 2:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep3[w];
					break;
				case 3:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep4[w];
					break;
				case 4:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep5[w];
					break;
				case 5:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep6[w];
					break;
				case 6:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep7[w];
					break;
				case 7:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep8[w];
					break;
				case 8:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep9[w];
					break;
				case 9:
					for(w=0;w<SOR*OSZ;w++)inputkep[w]=kep10[w];
					break;
			}
			propogate();
			if(!backprop())okall=0;
			ErrorSum+=error;
		}
		prcnt++;
	}
	s.sprintf("Propogation cycle count=%d",prcnt);
	Label2->Caption=s;
	ShowMessage("Learn finished");
}
//---------------------------------------------------------------------------



